/**
  \file   a2acc.h
  \brief       ( )
  \author  
  \date   13.12.1990
*/

#ifndef A2ACC_H
#define A2ACC_H
#ifndef H_A2ACC
#define H_A2ACC
#pragma pack(push, 8)

#ifndef H_A2DDT
# include "a2ddt.h"
#endif

enum EAcsErrcodes ///   
{
   EA_OM  = (-81), ///<  
   EA_UV  = (-82), ///<   
   EA_MK  = (-84), ///<   
   EA_RV  = (-85), ///<   
   EA_AC  = (-86), ///<   
   EA_MS  = (-87), ///<   
   EA_KL  = (-88), ///<    
   EA_UK  = (-89), ///<     
   EA_KRD = (-90), ///<     
   EA_PC  = (-91), ///<    
// EA_RT  = (-92),
   EA_PF  = (-93), ///<   
   EA_CC  = (-94), ///<    
   EA_CT  = (-95), ///<    
   EA_DK  = (-96), ///<   
};

#define ACSPTREE AcsPTREE
#define AcsPTREE(pacc) pacc->pt ///<     

#define ACSPDDT AcsPDDT
#define AcsPDDT(pacc) pacc->pd ///<     

#define ACSLVL AcsLVL
#define AcsLVL(pacc) pacc->lvl ///<      ( )

#define ACSGLVL AcsGLVL
#define AcsGLVL(pacc) pacc->gllvl ///<      ( )

#define ACSKLVL AcsKLVL
#define AcsKLVL(pacc) pacc->keylvl ///< 1/0 == / 

#define ACSKEY AcsKEY
#define AcsKEY(pacc) pacc->keyno ///< 1/0 ==   /

#define ACSVTYPE AcsVTYPE
#define AcsVTYPE(pacc) pacc->type ///<      

#define ACSKTYPE AcsKTYPE
#define AcsKTYPE(pacc) pacc->ktype ///<      

#define ACSPF AcsPF
#define AcsPF(pacc) (pacc->pd->vx[pacc->pd->icl].pf) ///<      

#define ACSDKEY AcsDKEY
#define AcsDKEY(pacc) pacc->dk ///<     

#define ACSERMSGP AcsERMSGP
#define AcsERMSGP(pacc,t) pacc->emsg=t ///<       
#define ACSERMSG AcsERMSG
#define AcsERMSG(pacc) pacc->emsg ///<       

/*!
  \def AcsTRACEP(pacc,t,s)
       
  \a pacc -    
  \a t -  : 0/1 ==  /.
  \a s -   ,  11   .
*/
#define ACSTRACEP AcsTRACEP
#define AcsTRACEP(pacc,t,s) \
  strncpy_s(pacc->trid, sizeof(pacc->trid), s, sizeof(pacc->trid)-1), \
  pacc->trc = t;
#define ACSTRACE AcsTRACE
#define AcsTRACE(pacc) pacc->trc ///<   

#define ACSKRFTRP AcsKRFTRP
#define AcsKRFTRP(pacc,t) pacc->rftr=t ///<       
#define ACSKRFTR AcsKRFTR
#define AcsKRFTR(pacc) (pacc->rftr) ///<       

#define ACSRSTOPP AcsRSTOPP
#define AcsRSTOPP(pacc,t) pacc->rstop=t ///<     
#define ACSRSTOP AcsRSTOP
#define AcsRSTOP(pacc) (pacc->rstop) ///<    

#define ACSATRP AcsATRP
#define AcsATRP(pacc,t) pacc->atr=t ///<   
#define ACSATR AcsATR
#define AcsATR(pacc) (pacc->atr) ///<   

#define ACSTRANS AcsTRANS
#define AcsTRANS(pacc) (pacc->pt->pdf->trType1) ///<   

#define AcsCTtre(pacc) TreeCT(pacc->pt) ///<    
#define AcsCTdod(pacc) DodCT (pacc->pd) ///<    

#if (defined(__FOR_WINDOWS__) || defined(__FOR_WIN32__)) && defined(H_A2NIKA)
# define ACSSKD(e,p,mv,ac,kt,k,dt,d) {*e=AcsSKD(p,mv,ac, kt,k, dt,d);}
# define ACSSK(e,p,mv,ac,kt,k)       {*e=AcsSK(p, mv,ac, kt,k);      }
# define ACSSD(e,p,mv,ac,dt,d)       {*e=AcsSD(p, mv,ac, dt,d);      }
# define ACSS(e,p,mv,ac)             {*e=AcsS(p, mv, ac);            }
# define ACSCPY(e,mv,p1,p2)          {*e=AcsCPY(mv, p1, &p2);        }
# define ACSDUP(e,ptr1,ptr2)         {*e=AcsDUP(ptr1, &ptr2);        }
# define ACSDLT(e,ptr1,ptr2)         {*e=AcsDLT(ptr1, &ptr2);        }
# define ACSSAV(err,pt)              {*err=AcsSAV(pt);               }
# define ACSRST(err,pt)              {*err=AcsRST(pt);               }
# define ACSCP(err,pac,fc)           {*err=AcsCP(pac);               }
#else
# define ACSSKD(e,p,mv,ac,kt,k,dt,d) {*e=a2accc(p,mv,ac, kt,k, dt,d,3);}
# define ACSSK(e,p,mv,ac,kt,k)       {*e=a2accc(p,mv,ac,kt,k,0,NULL,1);}
# define ACSSD(e,p,mv,ac,dt,d)       {*e=a2accc(p,mv,ac,0,NULL,dt,d,2);}
# define ACSS(e,p,mv,ac)           {*e=a2accc(p,mv,ac,0,NULL,0,NULL,0);}
# define ACSCPY(e,mv,p1,p2)       {*e=a2accc(p1,S_O,mv,0,NULL,0,&p2,2);}
# define ACSDUP(e,ptr1,ptr2) {*e=a2accc(ptr1,S_O,D_P,0,NULL,0,&ptr2,2);}
# define ACSDLT(e,ptr1,ptr2) {*e=a2accc(ptr1,S_O,R_C,0,NULL,0,&ptr2,2);}
# define ACSSAV(err,pt) {*err=a2accc(pt, S_O, S_P, 0, NULL, 0,NULL, 0);}
# define ACSRST(err,pt) {*err=a2accc(pt, S_O, R_P, 0, NULL, 0,NULL, 0);}
# define ACSCP(err,pac,fc)                a2dacp(err, pac->pt->pdf, fc)
#endif

/**
    #a2accbt() [  ]
*/
enum EAccBT
{
   ACS_TERM   =  1, ///<   
   ACS_NTERM  =  2, ///<   
   ACS_EMP    =  4, ///<  
   ACS_NEMP   =  8, ///<  
   ACS_NTERMF = 16, ///<       (forward)
   ACS_NTERMB = 32, ///<       (back)

   ACS_RY = 1,      ///<  
   ACS_UP = 2,      ///<  
   ACS_DO = 3,      ///<  
};

/*------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif

#if (defined(__FOR_WINDOWS__) || defined(__FOR_WIN32__)) && defined(H_A2NIKA) && !defined(SOURCE_A2ACCESS)
# define a2accop(e,dfile,tfile,disp,blks,psw,user) AcsOpen(e,dfile,tfile,disp)
# define a2accop_ex(e,dfile,tfile,disp,blks,psw,user,s,t) AcsOpenEx(e,dfile,tfile,disp,s,t)
# define a2acccl AcsClose
#else
 ACCESS *a2accop (
    int *pe, char *dod,char *tre, int disp, int *pblks, void *psw,void *user
 );
 ACCESS *a2accop_ex
 (  int *pe, char *dod,char *tre, int disp, int *pblks
    , void *psw,void *user
    , a2dioSubscribeSet* s, unsigned tout
 );

 int a2acccl ( ACCESS *ptacc ) ;
#endif

#ifdef __cplusplus
}
#endif

#pragma pack (pop)
#endif /* H_A2ACC  */
#endif /* A2ACC_H  */
