/**
  \file   a2conv.h
  \brief   ()  -  
  \author  
  \author  
  \date   03.03.1992
*/

#ifndef   H_A2CONV
#define   H_A2CONV
#pragma pack(push, 8)

#define W17_PFORM 1

#ifndef H_A2SYSDEF
# include "a2sysdef.h"
#endif
#ifndef H_A2TRDEF
# include "a2trdef.h"
#endif

/**
       
*/
enum EConvErrcodes
{
   ERDAT0   =  -1, ///<     0
   ERTYPIN  =  -2, ///<   
   ERTYPOUT =  -3, ///<   
   ERLIMIT  =  -4, ///<   
   ERNTEXT  =  -5, ///<    
   ERTHXDC  =  -6, ///<     
   ERLHXDC  =  -7, ///<      
   ERLDSC0  =  -8, ///< pout==NULL,typout==ldsc
   ERDATE   =  -9, ///<  
   ERTIME   = -10, ///<  
   ERTXT0   = -11, ///<   == 0
   ERFPR    = -12, ///<   (T<->FB)
   //
   EPPICL0  = -21, ///<   == 0
   EPPTLTH  = -22, ///<   !=  
   EPWNMON  = -23, ///<   
   //
   EWTYPE   = -31, ///<  
   EWTOUT   = -32, ///<    == 0
   EWTIN    = -33, ///<    < 2
   EWFRM    = -34, ///<  

   EMKOP    = -41, ///<     0..99
   EMMAX    = -42, ///<  > 999,000,000,000,000
   EMPET    = -43, ///<  
   EMFPR    = -44, ///<  
};

/**
      
  \note     
*/
enum EConvConstants
{
   MFRST   = 10000, ///<  
   MSCND   =   100, ///<  
   YMAX    =  2500, ///<  
   LEXT    =   256, ///<  
   PWINCHR =   '?', ///<  
   PWINMON =   '!', ///<    
};

/**
      
  \note     
*/
enum EConvFlags
{
   FPRLEFT   =  1, ///<  
   FPRPLUS   =  2, ///< '+'   
   FPRBLNK   =  4, ///<    
   FPRDECP   =  8, ///< '#'   printf()
   FPRZERO   = 16, ///<  
   //  
   DFZERO =    64, ///<    (1 == )
   DFBLNK =   128, ///<   (1 == )
   DFYEAR =   256, ///< 4    (0 == 2)
   DFMNAM =   512, ///<   (0 ==  )
   DFNOFL =  1024, ///<    (0 == )
   DFAUPL =  2048, ///<     
   DFFUPL =  4096, ///<     
   DFSNAM =  8192, ///<   (0 == )
   DFCURY = 16384, ///<  0    (1 == )
   DFADIN = 32768, ///<   (1 ==  )
   //
   DFND   =     1, ///< 
   DFNM   =     2, ///< 
   DFNY   =     3, ///< 
   //
   DFD1   =     4, ///<  
   DFD2   =    16, ///<  
   DFD3   =    64, ///<  
   //  
   DFAPM  =   256, ///< ante or post meridiem (am/pm)
   DFUPL  =   512, ///<    AM/PM
};

#if W17_PFORM
#define  FPRtMASK 0xE0
#define  FPRtSHFT    5
#endif

/**
  \brief    
  \note     
*/
struct flcnv
{
   char    flags;    ///<  #EConvFlags
   char    width;    ///< 
   char    prcsn[3]; ///<    
   short   dtfr;     ///<   /
   char    dlm;      ///<  (, )
   int     ltxt;     ///<  
   char    zero;     ///<    
   char    decp;     ///<   
   char    decd;     ///<    
};
typedef struct flcnv FLCNV; ///<    

/**
  \brief    
  \note     
*/
struct fpr
{
   char    flags; ///<  #EConvFlags
   char    width; ///< 
   char    prcsn; ///< 
   char    zero;  ///<    
   char    decp;  ///<   
   char    decd;  ///<    
};
typedef struct fpr FPR; ///<    

/**
  \brief   
  \note     
*/
struct fdt
{
   short   dtfr; ///<  #EConvFlags
   char    dlm;  ///< 
};
typedef struct fdt FDT; ///<   

#ifdef __cplusplus
 extern "C" {
#endif

/**
   
  \param typinp  [in] -   #ENikaDataTypes
  \param pin     [in] -    
  \param typoutp [in] -   #ENikaDataTypes
  \param pout   [out] -        
  \result 0   
*/
A2EXT int A2PAS a2conv (char typinp,void *pin, char typoutp,void *pout);

int a2convb  (char  typinp,void *pin,char  typoutp,void *pout,void  *pf);
int a2convc  (char  type,void *pout);
int a2convci (char *typinp,char *typoutp);
int a2convic (char  typinp,char *typoutp);
FLCNV *a2convga(void);

int a2convtp (char *tin,char *tout,char *pic);     /* text    --> picture */
int a2convpt (char *tin,char *tout,char *pic);     /* picture --> text    */

int a2convt  (char  typinp,void *pin,char  typoutp,void *pout,FLCNV *pfl);
int a2convf  (char  type,void *pf,void *pfl);
void *a2convr(void *pfl);
int a2convtc (char *typinp,void *pin,char *typoutp,void *pout);
int a2convttc(char *typinp,void *pin,char *typoutp,void *pout,FLCNV *pfl);
int a2convbtc(char *typinp,void *pin,char *typoutp,void *pout,void  *pf);
int a2convl  (char  type,void *pf);

int a2convw (char *tin,char *tout,char type); /* text --> window d/t form */

/**
        
  \param num [in] -     
  \param ord [in] -   #ENumTxt_Ordnum
  \param rod [in] -  #ENumTxt_Rod
  \param pad [in] -  #ENumTxt_Pad
  \param reg [in] -  #ENumTxt_Flags: #A2NT_REGs + #A2DT_DEL0
  \param tx [out] -    
  \param sz [in] -  
  \return    0
*/
A2EXT int A2PAS a2numtxt(double num,int ord,int rod,int pad,int reg,char *tx,int sz);

/**
      
  \param val  [in] -  
  \param prec [in] -     ( 6)
  \param flags [in] - :
    (#ENumTxt_Pad)    (#A2NT_LOWER, #A2NT_UPPER, #A2NT_FUPPER)
  \param tx [out] -    
  \param sz [in] -  
  \return    0
*/
A2EXT int A2PAS a2convDoubleTxt(double val, int prec, int flags, char *tx, int sz);

/**
    (double)   
  \param money  [in] -  
  \param flags  [in] - :
    (#ENumTxt_Pad)    (#A2NT_LOWER, #A2NT_UPPER, #A2NT_FUPPER)
  \param tx    [out] -    
  \param sz [in] -  
  \param valuta [in] -     
   : "///", "///", ""
  \return    0
  \note     DLL  a2nika32
*/
A2EXT int A2PAS a2convMoneyTxt(double money, int flags,char *tx,int sz,char *valuta);

/**
    (long)   
  \param date  [in] -     ( + 100* + 10000*)
  \param flags [in] - : #ENumTxt_Pad, #A2NT_REGs, #A2MT_KOPs
  \param tx   [out] -    
  \param sz [in] -  
  \return    0
  \note     DLL  a2nika32
*/
A2EXT void A2PAS a2convDateTxt(long date, int flags, char *tx, int sz);

enum ENumTxt_Ordnum ///   
{
   A2NT_NUM, ///< =0 - 
   A2NT_ORD, ///< =1 - 
   A2NT_ONN  ///<   
};

enum ENumTxt_Rod ///    
{
   A2NT_MEN, ///< =0 -  
   A2NT_WOM, ///< =1 -  
   A2NT_MID, ///< =2 -  
   A2NT_PLU, ///< =3 -  
   A2NT_RNN  ///<   
};

enum ENumTxt_Pad /// 
{
   A2NT_IME, ///< =0 - 
   A2NT_VIN, ///< =1 - 
   A2NT_ROD, ///< =2 - 
   A2NT_DAT, ///< =3 - 
   A2NT_TVO, ///< =4 - 
   A2NT_PRE, ///< =5 - 
   A2NT_PNN  ///<   
};

enum ENumTxt_Flags      /// 
{
   A2NT_REGs   = 8+16,  ///<     
   A2NT_LOWER  = 0+0,   ///<  
   A2NT_UPPER  = 8+0,   ///<  
   A2NT_FUPPER = 0+16,  ///<  
   //
   A2MT_KOPs   = 32+64+128, ///<      
   A2MT_NOKOP  = 0+0,   ///<   
   A2MT_00KOP  = 32+0,  ///<    
   A2MT_TXKOP  = 0+64,  ///<    
   A2MT_NORUB  = 128,   ///<   
   //
   A2DT_DEL0   = 256,   ///<       
};

int a2convm (double mon,char *pt);
#define a2convmb(kop,pt) a2convm((kop)/100., pt)
int a2convmr(double rub,char *pt);
int a2convmk(int kop,char *pt);
int a2ConvMT(char typi,void *pi,char typo,void *po,void *pf,char* ptrn);

#ifdef __cplusplus
 }
#endif

#pragma pack (pop)
#endif /* H_A2CONV */
