/**
  \file   a2crypt.h
  \brief         28147-89
  \author  
  \date   13.12.1990
*/

#ifndef  H_A2CRYPT
#define  H_A2CRYPT
#pragma pack(push, 8)

#ifndef H_A2DIO
# include "a2dio.h"
#endif

#ifdef __cplusplus
 extern "C" {
#endif

/**
      
   :
   \a fnm [in] -      ;
   \a psw [out] -    ;
   \a mlen[in] -   
*/
typedef int (A2CALLBACK *PSWHOOK)(char *fnm, char *psw, int mlen); 

/**
            
  \param pswf [in] -   ,      
  \return    
*/
A2EXT void A2PAS a2SetPswFunc(PSWHOOK pswf);

/**
      
          
  \param flags [in] - (#EA2Crypt_Actions) +   (#EA2Crypt_Methods)
  \param Psw  [in/out] -   
  \param lPsw [in] -  
  \param src  [in/out] -    
  \param dst  [in/out] -    
  \param len  [in] -
  \param sync [in/out] -  ,    (   )
  \return    -
      #A2C_IMITO,  0   
  \note  (len % 8)   
*/
A2EXT long A2PAS a2Crypt(
   int flags,                             /* actions & methods    */
   char *Psw,int lPsw,                    /* for password set/get */
   void *src,void *dst, unsigned len,     /* from, to, how        */
   long sync[2]                     /* Initial Gamma for Gamma... */
);

enum EA2Crypt_Actions  ///   
{
   A2C_SETPSW  = 0x01, ///<   ( 32 )
   A2C_GETPSW  = 0x02, ///<    ( 32 )
   A2C_ENCRYPT = 0x04, ///<  (src => dst)
   A2C_DECRYPT = 0x08, ///<  (dst => src)
   A2C_IMITO   = 0x10, ///<  - ( dst)
   A2C_ACTIONS = 0xFF  ///<  
};


enum EA2Crypt_Methods  ///   
{
  A2C_CHILD   = 0x100, ///<  ,  
  A2C_SIMPLE  = 0x200, ///<    28147-89,    64- 
  A2C_GAMMA   = 0x300, ///<      ( sync[]
  A2C_GAMMAB  = 0x400, ///<     ( sync[])
  A2C_METHODS = 0xF00  ///<   
};

#if !defined(H_A2NIKA) || !(defined(__FOR_WINDOWS__) || defined(__FOR_WIN32__))

/*--------------*/
/* a2g28147.asm */
/*--------------*/
enum { a2cpu8086=0, a2cpu286=2, a2cpu386=3 };
short A2getCPU (void); /*486... == a2cpu386*/
void A2crypSetKey  (char *buf, unsigned len);
#define A2_GET_KEY 0x1717
void A2crypSetChg  (char *buf);
void A2encrypChild (char *buf, unsigned len);
void A2decrypChild (char *buf, unsigned len);
void A2encrypSimple(char *buf, unsigned len);
void A2decrypSimple(char *buf, unsigned len);
void A2crypGamma   (char *buf, unsigned len, long sync[2]);
#define A2encrypGamma A2crypGamma
#define A2decrypGamma A2crypGamma
void A2encrypGammaB(char *buf, unsigned len, long sync[2]);
void A2decrypGammaB(char *buf, unsigned len, long sync[2]);
long A2crypImito   (char *buf, unsigned len);

/*-----------*/
/* a2crypt.c */
/*-----------*/
int  A2checkPSW (PDAFILE pda,char *crypPSW,char *psw, int defpsw);
int  A2linkCryptography(void);

/*------------*/
/* a2crypt1.c */
/*------------*/
int A2encrypFile(char *srcfile, char *dstfile, char *psw);
int A2decrypFile(char *srcfile, char *dstfile, char *psw);

#endif /* !(H_A2NIKA) || !(__FOR_WINDOWS__ || __FOR_WIN32__) */

#ifdef __cplusplus
 }
#endif

#pragma pack (pop)
#endif /*H_A2CRYPT*/
