/**
  \file   a2ddt.h
  \brief    -header
  \author  
  \date   13.12.1990
*/

#ifndef H_A2DDT
#define H_A2DDT
#pragma pack(push, 8)

/* COMMON STRUCTURES AND CONSTANTS DESCRIPTION */
#ifndef H_A2TR
# include "a2tr.h"
#endif

/**
     (DDT)
*/
enum EDdtErrcodes
{
   // 
   ED_SM  = ( -9), ///<  
   ED_SA  = (-10), ///<   
   ED_SB  = (-11), ///<  
   ED_SE  = (-12), ///<  
   ED_SP  = (-13), ///<  
   ED_SV  = (-14), ///<  
   ED_FERR= (-14), ///<   
   //  
   ED_OR  = (-51), ///<   
   ED_OM  = (-53), ///<  
   ED_OE  = (-54), ///<  
   ED_CT  = (-55), ///<    #DDT
   ED_FK  = (-56), ///<   
   ED_MAR = (-57), ///<      
   ED_MS  = (-58), ///<   
   ED_LN  = (-59), ///<   
   ED_MST = (-60), ///<     
   ED_MK  = (-61), ///<   
   ED_NA  = (-62), ///<   
   ED_MD  = (-63), ///<   
   ED_ANV = (-64), ///<      
   ED_AEV = (-65), ///<    
   ED_UK  = (-66), ///<  
   ED_AF  = (-67), ///<    
   ED_AMA = (-68), ///<      
   ED_KE  = (-69), ///<   
   ED_KN  = (-70), ///<   
   ED_AE  = (-71), ///<   
   ED_OK  = (-72), ///<      
   ED_PP  = (-73), ///<   
   ED_NP  = (-74), ///<    
   ED_RC  = (-75), ///<    
   ED_PC  = (-76), ///<    
   ED_DT  = (-77), ///<   
   ED_AC  = (-78)  ///<   
};

#define DodERMSGP(pddt,t) pddt->emsg=t ///<    #EM_S, #EM_T
#define DODERMSGP DodERMSGP
#define DDTERMSGP DodERMSGP

#define DodERMSG(pddt) (pddt->emsg) ///<   
#define DODERMSG DodERMSG
#define DDTERMSG DodERMSG

/**    #ETraceFlags    */
#if !defined(__FOR_WINDOWS__) && !defined(__FOR_WIN32__)
# define DodTRACEP(pddt,t,s)                      \
    a2ddttrp = a2ddttr,                           \
    strncpy_s(pddt->trid, sizeof(pddt->trid), s, sizeof(pddt->trid)-1), \
    pddt->trc = t;
#else
# define DodTRACEP(pddt,t,s)                      \
    strncpy_s(pddt->trid, sizeof(pddt->trid), s, sizeof(pddt->trid)-1), \
    pddt->trc = t;
#endif
#define DODTRACEP DodTRACEP
#define DDTTRACEP DodTRACEP

#define DodTRACE(pddt) (pddt->trc) ///<   
#define DODTRACE DodTRACE
#define DDTTRACE DodTRACE

#define DodASP(pddt,t) (pddt->as=(char)((pddt->as&~1)|t)) ///<      
#define DODASP DodASP
#define DDTASP DodASP
#define DodAS(pddt) (pddt->as&1) ///<      
#define DODAS DodAS
#define DDTAS DodAS

#define DodREFP(pddt,t) (pddt->as=(char)((pddt->as&~2)|(t<<1))) ///<      
#define DODREFP DodREFP
#define DDTREFP DodREFP
#define DodREF(pddt) ((pddt->as&2)>>1) ///<      
#define DODREF DodREF
#define DDTREF DodREF

#define DodLVL(pddt) (pddt->lvl) ///<   
#define DODLVL DodLVL
#define DDTLVL DodLVL
#define DodGLVL(pddt) (pddt->gllvl) ///<   
#define DODGLVL DodGLVL
#define DDTGLVL DodGLVL

#define DodVTYPE(pddt) pddt->vx[pddt->icl].type ///<  
#define DODVTYPE DodVTYPE
#define DDTVTYPE DodVTYPE
#define DodKTYPE(pddt) pddt->vx[pddt->icl].ktype ///<  
#define DODKTYPE DodKTYPE
#define DDTKTYPE DodKTYPE

#define DodKLVL(pddt) ((pddt->vx[pddt->icl].k) & 4) ///<  
#define DODKLVL DodKLVL
#define DDTKLVL DodKLVL
#define DodKN(pddt) ((pddt->vx[pddt->icl].k) & 1 ) ///< 
#define DODKN DodKN
#define DDTKN DodKN
#define DodATR(pddt) (((pddt->vx[pddt->icl].k)>>4) & 3 ) ///< 
#define DODATR DodATR
#define DDTATR DodATR

#define DodPF(pddt) (pddt->vx[pddt->icl].pf) ///<  
#define DODPF DodPF
#define DDTPF DodPF

#define DodDKEY(pddt) pddt->vx[pddt->icl].dk ///< - 
#define DODDKEY DodDKEY
#define DDTDKEY DodDKEY
#define DodUT(pddt) pddt->vx[pddt->icl].u_t ///< - 
#define DODUT DodUT
#define DDTUT DodUT

#define DodTRANS(pddt) (pddt->n->pdf->trType1) ///<  
#define DODTRANS DodTRANS
#define DDTTRANS DodTRANS

#define DodCT(pddt) ((int)pddt->n->pdf->blk0.codeTable) ///<  

#define DODSWKD DDTSWKD
#define DODSWK  DDTSWK
#define DODSWD  DDTSWD
#define DODSW   DDTSW
#define DODSRKD DDTSRKD
#define DODSRK  DDTSRK
#define DODSRD  DDTSRD
#define DODSR   DDTSR
#define DODCPY  DDTCPY
#define DODDUP  DDTDUP
#define DODDLT  DDTDLT
#define DODSAV  DDTSAV
#define DODRST  DDTRST
#define DODCP   DDTCP

#if (defined(__FOR_WINDOWS__) || defined(__FOR_WIN32__)) && defined(H_A2NIKA)
# define DDTSWKD(e,p,mv,ac,kt,k,dt,d) { *e=DodSWKD(p,mv,ac,kt,k,dt,d);      }
# define DDTSWK(e,p,mv,ac,kt,k)       { *e=DodSWK(p,mv,ac,kt,k);            }
# define DDTSWD(e,p,mv,ac,dt,d)       { *e=DodSWD(p,mv,ac,dt,d);            }
# define DDTSW(e,p,mv,ac,dt,d)        { *e=DodSW(p,mv,ac);                  }
# define DDTSRKD(e,p,mv,ac,kt,k,dt,d) { *e=DodSRKD(p,mv,ac,kt,k,dt,d);      }
# define DDTSRK(e,p,mv,ac,kt,k)       { *e=DodSRK(p,mv,ac,kt,k);            }
# define DDTSRD(e,p,mv,ac,dt,d)       { *e=DodSRD(p,mv,ac,dt,d);            }
# define DDTSR(e,p,mv,ac,dt,d)        { *e=DodSR(p,mv,ac);                  }
# define DDTCPY(e,mv,p1,p2)           { *e=DodCPY(mv,p1,&p2,2);             }
# define DDTDUP(e,p1,p2)              { *e=DodDUP(p1, &p2);                 }
# define DDTDLT(e,p1,p2)              { *e=DodDLT(p1, &p2);                 }
# define DDTSAV(e,pd)                 { *e=DodSAV(pd);                      }
# define DDTRST(e,pd)                 { *e=DodRST(pd);                      }
# define DDTCP(e,pd,fc)               { *e=DodCP(pd->k->pdf);               }
#else
# define DDTSWKD(e,p,mv,ac,kt,k,dt,d) { *e=a2ddtc (p,mv,ac,kt,k,dt,d,3);    }
# define DDTSWK(e,p,mv,ac,kt,k)       { *e=a2ddtc (p,mv,ac,kt,k,0,NULL,1);  }
# define DDTSWD(e,p,mv,ac,dt,d)       { *e=a2ddtc (p,mv,ac,0,NULL,dt,d,2);  }
# define DDTSW(e,p,mv,ac)             { *e=a2ddtc (p,mv,ac,0,NULL,0,NULL,0);}
# define DDTSRKD(e,p,mv,ac,kt,k,dt,d) { *e=a2ddtrc(p,mv,ac,kt,k,dt,d,3);    }
# define DDTSRK(e,p,mv,ac,kt,k)       { *e=a2ddtrc(p,mv,ac,kt,k,0,NULL,1);  }
# define DDTSRD(e,p,mv,ac,dt,d)       { *e=a2ddtrc(p,mv,ac,0,NULL,dt,d,2);  }
# define DDTSR(e,p,mv,ac)             { *e=a2ddtrc(p,mv,ac,0,NULL,0,NULL,0);}
# define DDTCPY(e,mv,p1,p2)           { *e=a2ddtc(p1,S_O,mv,0,NULL,0,&p2,2);}
# define DDTDUP(e,p1,p2)           { *e=a2ddtrc(p1,S_O,D_P,0,NULL,0,&p2, 2);}
# define DDTDLT(e,p1,p2)           { *e=a2ddtrc(p1,S_O,R_C,0,NULL,0,&p2, 2);}
# define DDTSAV(e,pd)              { *e=a2ddtrc(pd,S_O,S_P,0,NULL,0,NULL,0);}
# define DDTRST(e,pd)              { *e=a2ddtrc(pd,S_O,R_P,0,NULL,0,NULL,0);}
# define DDTCP(e,pd,fc)                            a2dacp(e, pd->k->pdf, fc)
#endif

#ifdef __cplusplus
 extern "C" {
#endif

#pragma pack (push, 1)

struct a2ddtatrStr ///  
{
   short    up; ///< 0-, >0- <0-  
   long  index; ///< -  */
   long    atr; ///< -  
   long   refr; ///< -   
   short level; ///< ,    
};

#pragma pack (pop)

#if !defined(__FOR_WINDOWS__) && !defined(__FOR_WIN32__)
 extern int (*a2ddttrp)( int err, DDT *pd, TCOMMAND *pc ) ;
 extern int a2ddttr( int err, DDT *pd, TCOMMAND *pc ) ;
 DDT *a2ddtop(int *perr, char *file, char disp, int *pblks, void *pass );
 int a2ddtcl( DDT *ptddt );
#endif

#if (defined(__FOR_WINDOWS__) || defined(__FOR_WIN32__)) && defined(H_A2NIKA) && !defined(SOURCE_A2ACCESS)
# define a2ddtop(pe,df,disp,pb,psw) DodOpen(pe,df,disp)
# define a2ddtop_ex(pe,df,disp,pb,psw,t) DodOpenEx(pe,df,disp,t)
# define a2ddtcl DodClose
#else
 DDT *a2ddtop(int *perr, char *file, char disp, int *pblks, void *pass );
 DDT *a2ddtop_ex(int *perr, char *file, char disp, int *pblks, void *pass, unsigned tout );
 int a2ddtcl( DDT *ptddt );
#endif

#ifndef H_A2NIKA
 TREE *a2ddtust( int *perr, DDT *pdod, long *pkey, long usk );
 TREE *a2ddtus ( int *perr, DDT *pdod, long *pkey, char act, long usk);
 void a2ddtret( int *perr, TREE *pdod_k, DDT* pdod );
 int a2ddtcmp( long *p1, long *p2, char type );
 int a2ddtr( DDT *pcddt, TCOMMAND *pcommand );
 int a2ddtrc(DDT *pd,char m,char a,char kt,void *k,char dt,void *d,char na);
 int a2ddt( DDT *pcddt, TCOMMAND *pcommand ) ;
 int a2ddtc( DDT *pd,char m,char a,char kt,void *k,char dt,void *d,char na);
#endif

/**
  \enum E_VertexAttrMask
     
  \sa chkVertex, mrkVertex
  \sa chkkey, mrkkey, arkey, parkey, gklvl, pklvl, chkdel, setdel, chkatr, mrkatr, galvl, palvl
*/
enum E_VertexAttrMask
{
   eVertex_Key  = 0x01, ///< =0x01  
   eVertex_AKey = 0x02, ///< =0x02   
   eVertex_KLvl = 0x04, ///< =0x04   
   eVertex_Del  = 0x08, ///< =0x08   
   eVertex_Attr = 0x10, ///< =0x10   
   eVertex_ALvl = 0x20  ///< =0x20    
};

#define chkVertex(val,mask)   (((val) & mask) != 0)          ///<  
#define mrkVertex(val,mask,t) (((val) & ~mask) | ((t)*mask)) ///<   

#define chkkey(c)   chkVertex(c, eVertex_Key)     ///< #eVertex_Key  -  
#define mrkkey(c,t) mrkVertex(c, eVertex_Key,  t) ///< #eVertex_Key  -  
#define arkey(c)    chkVertex(c, eVertex_AKey)    ///< #eVertex_AKey -    
#define parkey(c,t) mrkVertex(c, eVertex_AKey, t) ///< #eVertex_AKey -   
#define gklvl(c)    chkVertex(c, eVertex_KLvl)    ///< #eVertex_KLvl -   
#define pklvl(c,t)  mrkVertex(c, eVertex_KLvl, t) ///< #eVertex_KLvl -   
#define chkdel(c)   chkVertex(c, eVertex_Del)     ///< #eVertex_Del  -  
#define setdel(c,t) mrkVertex(c, eVertex_Del,  t) ///< #eVertex_Del  -   
#define chkatr(c)   chkVertex(c, eVertex_Attr)    ///< #eVertex_Attr -  
#define mrkatr(c,t) mrkVertex(c, eVertex_Attr, t) ///< #eVertex_Attr -   
#define galvl(c)    chkVertex(c, eVertex_ALvl)    ///< #eVertex_ALvl -   
#define palvl(c,t)  mrkVertex(c, eVertex_ALvl, t) ///< #eVertex_ALvl -    

#ifdef __cplusplus
 }
#endif

#pragma pack (pop)
#endif /* H_A2DDT */
