/**
  \file   a2dio.h
  \brief          
  \author  
  \date   13.12.1990
*/

#ifndef  H_A2DIO
#define  H_A2DIO
#pragma pack(push, 8)

#ifndef  ERRCODES_ONLY

#define  A2DA_H
#define  A2BUF_H

#ifndef  H_A2SYSDEF
# include "a2sysdef.h"
#endif

#ifndef H_A2DIOTRACK_H
# include "a2dioTrack.h"
#endif

#define USE_NEW_NETW

#if defined(__FOR_WIN32__) || defined(__FOR_DPMI32__)
# define USE_HASH_SEARCH
#endif

enum E_NOT_USED_ANY_MORE ///   (  )
{
   A2TOUT_DEF = 0 ///<     
};

enum E_DABLKSZ ///    DA
{
   A2MINDABLKSZ = 1024, ///< min
   A2DEFDABLKSZ = 2048, ///< default
   A2BIGDABLKSZ = 4096, ///< big
   A2MAXDABLKSZ = 8192, ///< max
};

/**
  \def A2MAXDABUF
       DA (  )
*/
#ifndef USE_NEW_NETW
#  define A2MAXDABUF 50
#else
#  if   defined(__FOR_DPMI32__) || defined(__FOR_WIN32__)
#    define A2MAXDABUF (256*1024*1024 / 2048)
#  elif defined(__FOR_DPMI16__) || defined(__FOR_WINDOWS__)
#    define A2MAXDABUF 512
#  else /* __FOR_DOS__ */
#    define A2MAXDABUF 128
#  endif
#endif

#define  A2TRMAX    30 ///<      

enum EDAOpen_Flags ///     
{
   A2DA_SJON  = 0x0100,     ///<  
   A2DA_SJOFF = 0x0200,     ///<  
   A2DA_RISK  = 0x0300,     ///<   ( ,         )
   A2DA_RISC  = A2DA_RISK,  ///< == #A2DA_RISK
   A2DA_QUIET = 0x0400,     ///<     
   A2DA_FMASK = (0x300),    ///<     
};

typedef struct a2dabuf  DABUF; ///<  DA 
typedef struct a2dafcb DAFILE; ///<  DA 
typedef DAFILE *PDAFILE; ///<    DA 

struct a2dabuf    ///    DA,    
{
   DAFILE   *da;  ///<  ,   
   long  blknmb;  ///<  
   DABUF  *next;  ///<    
   DABUF  *prev;  ///<    
   DABUF  *nextf; ///<     
   DABUF  *prevf; ///<     
#ifdef USE_NEW_NETW
   DABUF  *sNext; ///<      
   DABUF  *sPrev; ///<     
#endif
#ifdef USE_HASH_SEARCH
   DABUF  *hNext; ///<    
   DABUF  *hPrev; ///<    
#endif
   char    flags; ///<   DA 
   char     lock; ///<   
   char block[1]; ///<   
};

#pragma pack (push, 1)

struct dablk0 ///    
{
   struct a2datetm cordt; ///<   
   long         fcounter; ///<   
   short           flags; ///<  DA 
   short          syslth; ///<      
   short         blkflth; ///<    
   short         blkulth; ///< MAX     
   long         freelist; ///<     
   long          notused; ///<      
   long            space; ///<      
   long       reg_number; ///<    (     )
   char       version[5]; ///<   
   char        codeTable; ///<   #enum_A2CODE
   char         reserved; ///< 
   char    transLink[80]; ///<    
   unsigned long  trTime; ///<   
   char     cryptkey[32]; ///<  
};
typedef struct dablk0 DABLK0; ///<    

struct dablk ///     ( 0-)
{
   struct a2datetm cordt; ///<   
   long         fcounter; ///<   
   short           flags; ///<   
   long         userdata; ///<       
};
typedef struct dablk DABLK; ///<     ( 0-)

#pragma pack (pop)

struct a2dafcb ///   DA 
{
   char    cbname[3+1];   ///<  ("FCB")
   char    filename[256]; ///<  
   int     fn;            ///<  
   int     fnsj;          ///<  
   int     opennmb;       ///<  
   long    lBound;        ///<    
   DAFILE *next;          ///<    DA 
   DABUF  *buf;           ///<     
#ifdef USE_HASH_SEARCH
   int     daNum;         ///<  DA 
#endif
   char    server[16];    ///<     
   int     channel;       ///<     
   void    *ppd;          ///<      
   DABLK0  blk0;          ///<    DA 
   char    trType;        ///<      (0,'r','w') -      
   char    trNumb;        ///<     
   char    trType1;       ///<     
   char    key_wn[32];    ///<   (cryptkey)
   a2dioEventInfo* pTrackInfo; ///<        DA 
};

#endif /*ERRCODES_ONLY*/

#ifndef  A2DA_ERRCODES
#define  A2DA_ERRCODES

enum EDAErrcodes         ///   DA
{
   ER_DIO00  = (-100),   ///<   ( )    DA
   ER_DIO99  = (-199),   ///<      DA
   //
   ER_FEX    = (-101),   ///<   
   ER_NFEX   = (-102),   ///<   
   ER_CREAT  = (-103),   ///<   
   ER_OPEN   = (-104),   ///<   
   ER_DISP   = (-105),   ///<   
   ER_PSWD   = (-106),   ///<  
   ER_CLS    = (-107),   ///<    
   ER_DELET  = (-108),   ///<    
   ER_RENAM  = (-109),   ///<   
   ER_BSIZE  = (-110),   ///<   
   ER_RD     = (-111),   ///<   
   ER_WR     = (-112),   ///<   
   ER_SEEK   = (-113),   ///<      (seek error)
   ER_LSRD   = (-114),   ///<      
   ER_LSWR   = (-115),   ///<      
   ER_NMFB   = (-116),   ///<   
   ER_NOBUF  = (-117),   ///<   
   ER_NOBLK  = (-118),   ///<   
   ER_BADTBL = (-119),   ///<     DA
   ER_BFREE  = (-120),   ///<    
   ER_BNOFR  = (-121),   ///<    
   ER_NOFIX  = (-122),   ///<   
   ER_MAL    = (-123),   ///<     DA
   ER_NETLI  = (-124),   ///<    
   ER_NOTDA  = (-125),   ///<    DA 
   ER_EMPTY  = (-126),   ///<  
   ER_ALROP  = (-127),   ///<   
   ER_OCRYP  = (-128),   ///<     
   ER_OPSW   = (-129),   ///<      
   ER_ORECL  = (-130),   ///<          
   ER_NOTSJ  = (-131),   ///<    
   ER_BADSJ  = (-132),   ///<   
   ER_RECLM  = (-133),   ///<     ( )
   ER_UNOSJ  = (-134),   ///<       -  
   ER_MISMSJ = (-135),   ///<      
   ER_RECBRK = (-136),   ///<  
   ER_BADTF  = (-137),   ///<     
   ER_MISMTF = (-138),   ///<        
   ER_TRTYPE = (-139),   ///<   
   ER_TRLIST = (-140),   ///<    
   ER_TRLSTB = (-141),   ///<     
   ER_TRTOUT = (-142),   ///<     
   ER_TROPEN = (-143),   ///<   
   ER_TRNOPN = (-144),   ///<    
   ER_NOWRTR = (-145),   ///<    
   ER_NORWTR = (-146),   ///<      
   ER_TRFAIL = (-147),   ///<   (    )
   ER_TRLICR = (-148),   ///<     
   ER_TRLIWR = (-149),   ///<      
   ER_NOCRYP = (-150),   ///<    
   ER_INHREM = (-151),   ///<     
   ER_386    = (-156),   ///<   I386  
   //
   ER_NETERR = (-160),   ///<  
   ER_NETENV = (-161),   ///<   
   ER_NETDUP = (-162),   ///<   
   ER_NETNMO = (-163),   ///<    
   ER_NETBNM = (-164),   ///<   
   ER_NETCFG = (-165),   ///<       
   ER_NETNOR = (-166),   ///<    
   ER_NETOVF = (-167),   ///<     
   ER_NETSER = (-168),   ///<    
   ER_NETCHN = (-169),   ///<      
   ER_CONNEC = (-170),   ///<    
   ER_NETVER = (-171),   ///<     
   ER_RESOVF = (-172),   ///<    
   ER_RESBDH = (-173),   ///<   
   ER_RESLCK = (-174),   ///<  
   ER_RESBTY = (-175),   ///<   
   ER_RESACK = (-176),   ///<      
   ER_LONGST = (-177),   ///<      
   ER_FILOVF = (-178),   ///<   
   ER_REMUNC = (-179),   ///<     
   ER_BADNDA = (-180),   ///<  DA   
   ER_PRCOVF = (-181),   ///<    
   ER_STKOVF = (-182),   ///<    
   ER_BADPKT = (-183),   ///<     
   //
   ER_NOTYET = (-198),   ///<   
   ER_UNKN   = (-199),   ///<  
};

#endif /*A2DA_ERRCODES*/

#ifndef  ERRCODES_ONLY

/*-----------------------------------------------------------------*/
/* function prototypes                                             */
/*-----------------------------------------------------------------*/

#ifdef __cplusplus
 extern "C" {
#endif

/**
  /   
  \param prm [in] -     #EDAPrm
  \param val [in] -     (   )
  \return   ,   ,  0
*/
EXTERNFUNC int A2PAS a2daPrm (int prm, int val);

enum EDAPrm ///       #a2daPrm
{
   A2DA_GETNBUF,    ///<      DA
   A2DA_SETNBUF,    ///<      DA . #A2MAXDABUF
   A2DA_GETBLKS,    ///<   
   A2DA_SETBLKS,    ///<    . #E_DABLKSZ
   A2DA_GETMSGL,    ///<    
   A2DA_SETMSGL,    ///<    
   A2DA_GETIGNERR,  ///<    
   A2DA_SETIGNERR,  ///<     (   )
   A2DA_GETFLAGS,   ///<   . #EDAPrm_Flags
   A2DA_RSTFLAGS,   ///<    , \a val -    
   A2DA_SETFLAGS,   ///<  , \a val -     [#EDAPrm_Flags]
   A2DA_RESFLAGS,   ///<  , \a val -     [#EDAPrm_Flags]
   A2DA_GETVERSION, ///<     
   A2DA_GETMSGLANG, ///<     ('R' - , 'E' - )
   A2DA_SETMSGLANG, ///<    
   A2DA_GETNETNBIO, ///<   0,   NetBios      
   A2DA_SETNETNBIO, ///<     NetBios
   A2DA_GETNETTCP,  ///<   0,   TCP/IP      
   A2DA_SETNETTCP,  ///<     TCP/IP
   A2DA_GETNETPIPE, ///<   0,   Pipe      
   A2DA_SETNETPIPE, ///<     Pipe
   A2DA_GETCSSYNCS, ///<   0,       -  (  )
   A2DA_SETCSSYNCS, ///<     
   A2DA_GETTRECODE, ///<      
   A2DA_SETTRECODE, ///<      
   A2DA_GETAPPCODE, ///<      (  )
   A2DA_SETAPPCODE, ///<       (  )
};

enum EDAPrm_Flags ///  DA (. #a2daPrm, #A2DA_GETFLAGS, #A2DA_RSTFLAGS, #A2DA_SETFLAGS, #A2DA_RESFLAGS)
{
   A2DA_F_FOR_WINDOWS   = 0x001, ///< WINDOWS ( ,  WIN32   0)
   A2DA_F_NET_LINKED    = 0x002, ///<    ( )
   A2DA_F_CRYPT_LINKED  = 0x004, ///<   ( )
   A2DA_F_NO_LINK_TRANS = 0x008, ///<          (/)
   A2DA_F_HIDEERRMSGS   = 0x010, ///<     (/)
   A2DA_F_NOLOADMSGFILE = 0x020, ///<     (/)
   A2DA_F_AUTORECLM     = 0x040, ///<       (/)
   A2DA_F_AUTORECLMERR  = 0x0C0, ///<          (/)
   A2DA_F_ALLRW         = 0x0F8, ///<      
   A2DA_F_FLATMEM       = 0x800, ///< ''  ( ,  WIN32   0)
};

#define a2daMsgLvl(lvl)       a2daPrm(A2DA_SETMSGL, lvl)   ///<      
#define a2GetNBuf()           a2daPrm(A2DA_GETNBUF, 0)     ///<      DA
#define a2SetNBuf(NBuf)       a2daPrm(A2DA_SETNBUF, NBuf)  ///<      DA
#define a2daSetBlkSize(blksz) a2daPrm(A2DA_SETBLKS, blksz) ///<      DA

#ifndef H_A2NIKA

DAFILE *a2daop (
   int *err, char *fname, int disp, int *blksz, char *passw
);

DAFILE *a2daopr (
   int *err, char *fname, char *passw
);

DAFILE *a2daop_ex (
   int *err, char *fname, int disp, int *blksz, char *passw,
   a2dioSubscribeSet*sub, unsigned tout
);

int a2dacl (int *err, DAFILE *pda, long *fcounter);

void a2dacp(int *perr, DAFILE *pda, long *fcounter);

void *a2dagf (int* err, DAFILE *pda, long *blkn);
void  a2dals (int* err, DAFILE *pda, long *blkn);
void  a2dapf (int* err, DAFILE *pda, long *blkn);
void *a2dard (int* err, DAFILE *pda, long *blkn);
void  a2dawr (int* err, DAFILE *pda, long *blkn);
int   a2dasj (DAFILE *pda, int on);


#endif /*H_A2NIKA*/

typedef int (*A2HOOKE)(LP_CHAR, int); ///<    #a2SetErrHook()

/**
        
  \param fhook    #A2HOOKE,
          
  \return    
*/
A2EXT A2HOOKE A2PAS a2SetErrHook(A2HOOKE fhook);


#ifdef __cplusplus
 }
#endif

#endif /*ERRCODES_ONLY*/

#pragma pack (pop)
#endif /*H_A2DIO*/
