/**
  \file   a2dioTrack.h
  \brief        
  \author  
  \date   10.07.2005
*/

#ifndef H_A2DIOTRACK_H
#define H_A2DIOTRACK_H
#pragma pack(push, 8)

#ifdef __cplusplus
extern "C" {
#endif
/*===========================================================================*/

enum a2TrackEvent ///  
{
   eTrack_OpenFile,   ///< = 0 --  
   eTrack_CloseFile,  ///< = 1 --  
   eTrack_TrBegin,    ///< = 2 --  
   eTrack_TrEnd,      ///< = 3 --  
   eTrack_TrCancel,   ///< = 4 --  
   eTrack_CheckPoint, ///< = 5 --  
   eTrack_WriteBlock, ///< = 6 --  
   eTrack_NNN         ///<   
};

typedef struct a2trtree TREE;
typedef struct a2dioEventInfo a2dioEventInfo; ///<    
typedef struct a2dioSubscribeSet a2dioSubscribeSet; ///<      DA
///<      #TreeOpenEx(), #DodOpenEx()  #AcsOpenEx()

typedef void (*a2dioEventCallback)   ///    
(
   enum a2TrackEvent     eEventCode, ///<    #a2TrackEvent
   const a2dioEventInfo* pcEventInfo ///<   
);

struct a2dioSubscribeSet ///          DA 
{
   void*              pvUserData;    ///<   -    
   a2dioEventCallback pfOpen;        ///<     DA 
   a2dioEventCallback pfClose;       ///<     DA 
   a2dioEventCallback pfTrBeg;       ///<     
   a2dioEventCallback pfTrEnd;       ///<      
   a2dioEventCallback pfTrCancel;    ///<      
   a2dioEventCallback pfCkPoint;     ///<      
   a2dioEventCallback pfWrBlock;     ///<        
};

struct a2dioEventInfo                ///     DA 
{
   const char *pcszFileName;         ///<   (     DA )
   int         iNikaResult;          ///<        
   long        lFileCounter;         ///<      DA
   union
   {
      long     lBlockNumber;         ///<  :
      ///< #eTrack_OpenFile, #eTrack_CloseFile, #eTrack_CheckPoint, #eTrack_WriteBlock)
      TREE*    pTrFirstTree;         ///<         :
      ///< #eTrack_TrBegin, #eTrack_TrEnd, #eTrack_TrCancel
   } data;

   a2dioSubscribeSet subscribe;      ///<    DA 
};

/*===========================================================================*/
#ifdef __cplusplus
}

#pragma pack (pop)
#endif
#endif /*H_A2DIOTRACK_H*/
