/**
  \file   a2grdef.h
  \brief     () -   
  \author  
  \date   13.12.1990
*/

#ifndef H_A2GRDEF
#define H_A2GRDEF
#pragma pack(push, 8)

struct _vsys ///  
{
   BYTE adap1; ///<  
   BYTE disp1; ///<  
   BYTE adap2; ///<  
   BYTE disp2; ///<       
};
typedef struct _vsys VSYS; ///<  

enum E_VSYS_adap ///  
{
   _NONE    = 0x00, ///< 
   _MDA     = 0x01, ///< IBM Monochrome Display Adapter
   _CGA     = 0x02, ///< Color Graphic Adapter
   _HGC     = 0x03, ///< Herculles Graphic Controller
   _HGCPLUS = 0x04, ///< Herculles Plus Graphic Controller
   _INCOLOR = 0x05, ///< Herculles with InColor card
   _PGC     = 0x06, ///< Professional Graphic Controller
   _EGA     = 0x07, ///< Enhanced Graphic Adapter
   _VGA     = 0x08, ///< Video Graphic Array
   _MCGA    = 0x09, ///< Multi Color Graphic Adapter
   _AUNKN   = 0xFF  ///< 
};

enum E_VSYS_disp ///  
{
   _MONO   = 0x01, ///< 
   _COLOR  = 0x02, ///< 
   _ECOLOR = 0x03, ///<  EGA
   _AMONO  = 0x04, ///< VGA 
   _ACOLOR = 0x05  ///< VGA 
};


struct _mdesc ///  
{
   short ncols; ///<  
   short nrows; ///<  
   short hight; ///<    
   short color; ///<  
   short npage; ///<    
   short flags; ///<    #EMDESC_flags
};
typedef struct _mdesc MDESC; ///<  

enum EMDESC_flags ///   
{
   F_TEXT = 0x01, ///< 
   F_GRPH = 0x02, ///< 
   F_COLO = 0x04, ///< 
   F_MONO = 0x08, ///< 
   F_HERC = 0x10, ///< herculles mode
   F_ENBL = 0x20  ///<  
};

enum E_ScreenLimits ///    
{
   MAX_COL = 200,         ///<   
   MAX_ROW = 100,         ///<   
   LIN_MAX = (MAX_COL*2), ///<    
   CLM_MAX = (MAX_ROW*2)  ///<    
};

enum E_VideoModes ///  
{
   TEXTBW40     = 0x00, ///<   40x25
   TEXTC40      = 0x01, ///<   40x25
   TEXTBW80     = 0x02, ///<   80x25
   TEXTC80      = 0x03, ///<   80x25
   MRES4COLOR   = 0x04, ///< CGA  4  320x200
   MRES2COLOR   = 0x05, ///< CGA  2  320x200
   HRES2COLOR   = 0x06, ///< EGA  2  640x200
   TEXTMONO     = 0x07, ///<   80x25
   HERCMONO     = 0x08, ///< Herculles  2  80x25
   HERCCOLOR    = 0x09, ///< Herculles  16  80x25
   TEXTMAX80    = 0x0A, ///<   80x43  80x50
   TEXT25X132   = 0x0B, ///<   132x25
   TEXTMAX132   = 0x0C, ///<   132x43  132x50
   MRES16COLOR  = 0x0D, ///< EGA  16  320x200
   HRES16COLOR  = 0x0E, ///< EGA  16  640x200
   ERES4COLOR   = 0x0F, ///< EGA  4  640x350
   ERES16COLOR  = 0x10, ///< EGA  16  640x350
   VRES2COLOR   = 0x11, ///< VGA  2  640x480
   VRES16COLOR  = 0x12, ///< VGA  16  640x480
   MRES256COLOR = 0x13  ///< VGA  256  320x200
};

#pragma pack (pop)
#endif /* H_A2GRDEF */
