/**
  \file   a2grtxt.h
  \brief     -      
  \author  
  \date   13.12.1990
*/

#ifndef H_A2GRTXT
#define H_A2GRTXT
#pragma pack(push, 8)

#ifndef H_A2SYSDEF
# include "a2sysdef.h"
#endif

#ifndef __STRIP_TV__

#ifndef H_A2SYSTEM
# include "a2system.h"
#endif

#ifndef H_A2SYSDEF
# include "a2sysdef.h"
#endif

#ifndef SERVER
# ifndef H_A2GRDEF
#  include "a2grdef.h"
# endif
# ifndef H_A2TVDEF
#  include "a2tvdef.h"
# endif
#else
 typedef struct { short row, clm; }                                 TINT;
 typedef struct { short ncols, nrows, hight, color, npage, flags; } MDESC;
#endif

enum A2TV_command ///    a2tv0xxx() 
{
   A2TV_ON  = 1,         ///< 
   A2TV_OFF = 0,         ///< 
   A2TV_ASK = -1717,     ///<  
   A2TV_GET = A2TV_ASK,  ///<  ASK
   A2TV_SET = 2          ///< 
};

struct _tv0_win ///    
{
   TINT p;      ///<    
   TINT s;      ///< 
};
typedef struct _tv0_win TV0_WIN; ///<    

struct _a2cinf ///   
{
   int on;     ///<   
   TINT pos;   ///< 
   int size;   ///< 
   TV0_WIN tw; ///< 
};
typedef struct _a2cinf A2CINF; ///<   

struct _a2frame ///      
{
  BYTE  v; ///<   
  BYTE  h; ///<   
  BYTE ul; ///<   
  BYTE ur; ///<   
  BYTE ll; ///<   
  BYTE lr; ///<   
  BYTE v1; ///<   
  BYTE h1; ///<   
};
typedef struct _a2frame A2FRAME; ///<     

struct _a2brdext ///     
{
   BYTE l_brk;   ///<   '['
   BYTE r_brk;   ///<   ']'
   BYTE c_sys;   ///<   
   BYTE c_min;   ///<  
   BYTE c_max;   ///<  
   BYTE c_rst;   ///<    
   BYTE u_arrow; ///<  
   BYTE d_arrow; ///<  
   BYTE l_arrow; ///<  
   BYTE r_arrow; ///<  
   BYTE h_norm;  ///<   
   BYTE h_tumb;  ///<   
   BYTE v_norm;  ///<          
   BYTE v_tumb;  ///<    
   BYTE u_half;  ///<  
   BYTE d_half;  ///<  
};
typedef struct _a2brdext A2BRDEXT; ///<     

#ifndef DEF_TINT_MACROS
#define DEF_TINT_MACROS
# define GETWIN(x)       MOVETINT(x.p,window.p); MOVETINT(x.s,window.s)
# define MOVETINT(x,y)   x=y
# define SUBTTINT(z,x,y) z.row=(short)(x.row-y.row); z.clm=(short)(x.clm-y.clm)
# define ADDTINT(z,x,y)  z.row=(short)(x.row+y.row); z.clm=(short)(x.clm+y.clm)
# define SETTINT(x,a,b)  x.row=(short)(a); x.clm=(short)(b)
#endif

extern A2FRAME A2frame[5]; ///<  : 1x1 : 1x2 : 2x1 : 2x2

#ifdef __cplusplus
extern "C" {
#endif

enum A2TV_MVcode ///  #a2tvmvm()
{
   MV_LIN = 0, ///<     
   MV_COL = 1, ///<     
   MV_GET = 4, ///<     
   MV_SAV = 5, ///<    
   MV_RCL = 6  ///<    
};
/**
      
  \param scrpos [in] -     (2   )
  \param buffer [in/out] - /   
  \param nn [in] -    
  \param op [in] -  #A2TV_MVcode
*/
void a2tvmvm( int scrpos, void *buffer, int nn, int op );

/**
    
  \param cur [in] -  
  \return 0   
*/
int a2tv0cur( TINT cur );

/**
    
  \param size [in] -  
   -1 - , -2 - , #A2TV_ON, #A2TV_OFF, #A2TV_ASK
  \return     
*/
int a2tv0csz( int size );

/**
  / 
  \param viflg [in] - #A2TV_ON, #A2TV_OFF, #A2TV_ASK
  \return  
*/
int a2tv0con( int viflg );

/**
  /  
  \param mode [in] -   #A2TV_GET, #A2TV_SET
  \param cinf [in/out] -      #A2CINF
*/
void a2tv0cinf( int mode, A2CINF *cinf );

/**
     
  \return 0   
*/
int a2tv0op(void);

/**
     
  \return 0   
*/
void a2tv0cl(void);

/**
   
  \param vmode [in] -   #E_VideoModes
  \param save [in] -   0 --   
  \return 0   
*/
int a2tv0sm( int vmode, int save );

/**
   
  \param vmode [in] -   #E_VideoModes
  \return NULL   
*/
MDESC *a2tv0tm( int mode );

/**
    
  \param ul [in] -   
  \param sz [in] -  
*/
void a2tv0wnd( TINT ul, TINT sz );

/**
    
  \param ul [in] -   
  \param sz [in] -  
*/
void a2tv0scr( TINT ul, TINT sz );

/**
         
  \param flags [in] -   
  \return    
*/
void *a2tv0strw( int flags );

/**
      
  \param buffer [out] -    #a2tv0scr()
  \return 0   
*/
int a2tv0str( void *buffer );

/**
       
  \param buffer [in] -    #a2tv0scr()
  \return 0   
*/
int a2tv0rst( void *buffer );

/**
       
    
  \param buffer [in] -    #a2tv0scr()
  \return 0   
*/
int a2tv0rstf( void *buffer );

/**
     
  \param atr [in] -   
  \return 0   
*/
int a2tv0atr( int atr );

/**
   
  \param atr [in] -    
  \param filler [in] -  
  \return 0   
*/
int a2tv0clw(int atr, int filler); /* clear window          */

/**
  /   
  \param viflg [in] - #A2TV_ON, #A2TV_OFF, #A2TV_ASK
  \return  
*/
int a2tv0deplON (int on_off);

enum E_BorderFlags ///   
{
   BRD_00    = 0x0005, ///<  
   BRD_11    = 0x0001, ///< 1x1
   BRD_12    = 0x0002, ///< 1x2
   BRD_21    = 0x0003, ///< 2x1
   BRD_22    = 0x0004, ///< 2x2
   BRD_SHAD  = 0x0008, ///< 
   BRD_TUL   = 0x0010, ///<  
   BRD_TUC   = 0x0020, ///<  
   BRD_TUR   = 0x0030, ///<  
   BRD_TUP   = 0x0040, ///<   1 (0 - )
   BRD_EXPL  = 0x0080, ///< ' 
   BRD_SYS   = 0x0100, ///<   
   BRD_HSCR  = 0x0200, ///<  
   BRD_VSCR  = 0x0400, ///<  
   BRD_TWIN  = 0x0800, ///<   
   BRD_NEWSH = 0x1000, ///<   
   BRD_MAX   = 0x2000, ///<  
   BRD_MIN   = 0x4000, ///<  
   BRD_RST   = 0x6000  ///<   
};
/**
    
  \param atr [in] -  
  \param type [in] -   #E_BorderFlags
  \param ldatr [in] -  
  \param ld [in] -   
*/
void a2tv0brd( int atr, int type, int ldatr, LDSC *ld );

/**
       
  \param HOR [in] - 1 =  , 1 = 
  \param SET [in] - 1 = , 0 = 
  \param row [in] -  
  \param clm [in] -  
  \param atr [in] -  
*/
void a2tv0Tumb( int HOR, int SET, int row,int clm, int atr );

enum E_ScrollDirection ///  
{
   R_SCROLL = 1, ///< 
   L_SCROLL = 2, ///< 
   U_SCROLL = 3, ///< 
   D_SCROLL = 4  ///< 
};
/**
   
  \param dir [in] - 
  \param count [in] -   ()
  \param atr [in] -      
  \param filler [in] -  
*/
void a2tv0srl( int dir, int count, int atr, int filler );

/**
    
  \\param pos -      
  \\param attr - -1= , -2= , = 
*/
void a2tv0cpy (TINT pos, int atr);

/**
            
  \param atr [in] -   
  \param list [in] -    
  \return 0   
*/
int a2tv0chgl( int atr, LDSC *list );

enum E_ChangeMode ///    #a2tv0chg()
{
   BIGLAT = 1, ///<  
   BIGRUS = 2, ///<  
   ALLWND = 4, ///<  
   DIGITS = 8  ///< 
};
/**
      
  \param flags [in] -   #E_ChangeMode
  \param atr [in] -   
  \return 0   
*/
void a2tv0chg( int flags, int atr );

/**
     
  \param text [in] -   
  \param atr [in] -    
  \param ulw [in] -       
  \param start [in] -     
  \param stop [in] -     
  \return 0   
*/
int a2tv0wr( LDSC *text,int atr,TINT *ulw,TINT *start,TINT *stop );

/**
   
  \param atr [in] -    
  \param filler [in] -  
  \return 0   
*/
int a2tv0cls( int atr, int filler );

/**
      
*/
void a2tv0db(void);

/**
      (  )
*/
void a2tv0ndy(void);

/**
      ( + )
*/
void a2tv0dy(void);

/**
       '' 
  \param on_off [in] - 1 = , 0 = 
  \return  
*/
int a2tv0atrf(int on_off); /* on/off/ask (A2TV_ON/OFF/ASK) */

//   Win32    
//
#define a2tvtrace(op, mode, size, text)
//
enum E_RolMode
{
   A2ROL_MLIN = 1,
   A2ROL_CPOS = 2,
   A2ROL_TKEY = 3,
   A2ROL_WAIT = 4,
   A2ROL_MCOL = 5,
   A2ROL_MODE = 6,
   A2ROL_CSIZ = 7,
   A2ROL_TRON = (-1),
   A2ROL_TROF = (-2)
};
//
#define a2tvttron()            a2tvtrace(A2ROL_TRON, 0,    0, NULL)
#define a2tvtno a2tvttrof
#define a2tvttrof()            a2tvtrace(A2ROL_TROF, 0,    0, NULL)
#define a2tvtkey(code)         a2tvtrace(A2ROL_TKEY, code, 0, NULL)
#define a2tvtwait(msec)        a2tvtrace(A2ROL_WAIT, msec, 0, NULL)
#define a2tvtmode(mode,fsave)  a2tvtrace(A2ROL_MODE, mode, fsave, NULL)
#define a2tvtsiz a2tvtcsiz
#define a2tvtcsiz(size)        a2tvtrace(A2ROL_CSIZ, size, 0, NULL)
#define a2tvtcur a2tvtcpos
#define a2tvtcpos(pos)         a2tvtrace(A2ROL_CPOS, pos.row,pos.clm, NULL)
#define a2tvtout a2tvtmlin
#define a2tvtmlin(scrp,n,text) a2tvtrace(A2ROL_MLIN, scrp, n, text)
#define a2tvtram a2tvtmcol
#define a2tvtmcol(scrp,n,text) a2tvtrace(A2ROL_MCOL, scrp, n, text)

enum E_MsgOutFlags ///   #a2tvMsgOut()
{
   A2MSG_LEFT   = 0,    ///<  
   A2MSG_RIGHT  = 1,    ///<  
   A2MSG_CENTR  = 2,    ///< 
   A2MSG_NOSAVE = 0x100,///<     
   A2MSG_NOKEY  = 0x200,///<   
   A2MSG_CON    = 0x400,///<  
};
/**
     
  \param msg [in] -  
  \param atr [in] -     [-1   , -2   ]
  \param row [in] -     [ <0 : ROW=nrows+row ]
  \param col [in] -    
   [ <0 : COL=ncols+col, >800: COL=ncols/2+col-1000 ]
  \param len [in] -    [-1 = ncols, -2 = strlen(msg) ]
  \param flags [in] -  #E_MsgOutFlags
  \param limit [in] -    [ 1=1/18.2., 91=5., ... -1=MAX]
  \param keys [in] -  :
   0L -    
      -    
       , -1= , 0= 
  \return 0,   ,     
*/
int a2tvMsgOut (char *msg, int atr, int row,int col,int len, int flags, int limit, long keys);

/**
     
  \param msg [in] -  
  \param atr [in] -     [-1   , -2   ]
  \param row [in] -     [ <0 : ROW=nrows+row ]
  \param col [in] -    
   [ <0 : COL=ncols+col, >800: COL=ncols/2+col-1000 ]
  \param len [in] -    [-1 = ncols, -2 = strlen(msg) ]
*/
void a2tvStrOut (char *msg, int atr, int row,int col,int len);

/**
       
  \param msg [in] -  
  \return   
*/
int a2tvErrOut (char *msg);

/**
     
  \param msg [in] -  
  \param pause [in] -   (1 = 1/18.2 )
  \return   
*/
int a2tvInfOut (char *msg, int pause);

/**
        
  \param atr [in] -   
  \return   
*/
int a2calcatr( int atr );

struct _a2viewcfg ///   #a2view()
{
   int ulCol;               ///<       
   int ulRow;               ///<     
   int nCol;                ///<     
   int nRow;                ///<     
   unsigned char saveBgr;   ///<   1 = 
   unsigned char colorTi;   ///<    (0 = )
   unsigned char colorTx;   ///<   
   unsigned char colorSt;   ///<    (0 = )
   unsigned char colorHl;   ///<   
   unsigned char colorSl;   ///<   
   unsigned char TabSz;     ///<  
   unsigned char lockLeft;  ///<   
   unsigned char noDialog;  ///<  
   unsigned char useCursor; ///<  
   unsigned char caseSens;  ///<     
   char search_string[31];  ///<  
   int  (*file_op)(const char *fname, int oflags);     ///< -  
   int  (*file_cl)(int fh);                            ///< -  
   int  (*file_rd)(int fh, V_PTR buf, unsigned count); ///< -   
   long (*file_sk)(int fh, long pos, int from);        ///< -   
   int  (*getkey)(void);                               ///< -   
   int  (*prtchr)(int act, int chr);                   ///< -  
                            ///< [0 - , -1,-2 - ,  -   ]
   WORD BUF_PORTION;        ///<    [4096 .. 0x7F80]
   WORD maxlen;             ///<    10..1024
};
typedef struct _a2viewcfg A2VIEWCFG; ///<   #a2view()

/**
   
  \param fname [in] -    
  \param title [in] -  
  \return   
*/
int a2view (char *fname, char *title);

/**
  /   
  \param cfg [in/out] -        
  \param mode [in] -  0=, 1=
  \return   
*/
int a2viewCfg (A2VIEWCFG *cfg, char mode); /* 0-get, 1-set */

#ifdef __cplusplus
}
#endif

# endif /* __FOR_WINDOWS__ */

#pragma pack (pop)
#endif /* H_A2GRTXT */
