/**
  \file   a2mousew.h
  \brief  -   ''  
  \author  
  \date   13.12.1990
*/

#ifndef A2MOUSE_H
#define A2MOUSE_H
#pragma pack(push, 8)

/*================  a2mousew.h ========================*/
#include "a2tvdef.h"

                              /*   */
#define  OB_RGN   0x01                     /*  */
#define  OB_PCB   0x02                           /*  */
#define  OB_GRF   0x04        /*   */

#define  OB_CTRL  0x10    /*    */

/*  : */

#define SET_WND  0x100
#define WRK_WND  0x200
#define WRK_VSCR 0x300
#define WRK_HSCR 0x400

struct MouseRegion {int flags;
                    int type;
                    void *object;
                    TINT Pos;
                    TINT Size;
                    int trigger;
                    struct MouseRegion *prev;
                    struct MouseRegion *next;
                   };
typedef struct MouseRegion MR;

#define MOUSE_INC
#ifdef MOUSE_INC
#include "a2mouse.h"

struct CurrMouseEvent {int flags;
                       int type;
                       void *region;
                       a2M_CSTAT M_S;
                      };
typedef struct CurrMouseEvent CME;

/* extern CME a2_CME; */

#ifdef __cplusplus
extern "C" {
#endif

/*------ a2SetControlM -    ------*/
MR *a2SetControlM(int type, WCB *wnd, TINT *coor, TINT *size);
/* type: */
#define  A2M_FESC  1
#define  A2M_FF5   2
#define  A2M_FVSCR 3
#define  A2M_FHSCR 4

void a2IncludeMouse(void);
MR *a2SetNewListR(MR *NewMR);
int a2SetCursor(WCB *wcb);
CME *a2GetCME(void);
MR *a2AddRegion(int flags, int type,
                         int trigger, TINT *pos, TINT *size);
MR *a2AddObject(int flags, int type, int trigger, void *object);
int a2DelRegion(void *object);
int a2DelGroupR(void *object, int n_r);
int a2KeyMouse(int flags);
int a2CheckRegion(TINT *pos, TINT *size);
int a2CheckWindowPart(WCB *wcb, PCB *pcb);
int a2CheckMouse(MR *mr);
#ifdef __cplusplus
}
#endif
#endif

#pragma pack (pop)
#endif
/*=========================================================*/
