/**
  \file   a2net.h
  \brief    - 
  \author  
  \date   13.12.1990
*/

#ifndef  H_A2NET
#define  H_A2NET

#ifndef H_A2SYSDEF
# include "a2sysdef.h"
#endif

#pragma pack (push, 1)
#ifdef __cplusplus
 extern "C" {
#endif

#ifdef H_A2SYSDEF

  enum a2NetLinkMode ///      - #a2NetLink()
  {
     A2NET_CFGFILE,  ///<     (2- )
     A2NET_DIRNAME,  ///<    
     A2NET_UNIQUE    ///<       (2- )
  };

  /**
        
    \param mode [in] --     #a2NetLinkMode
    \param name [in] --   (   )
      NetBios         NetBios
      TCP/IP    
    \return 0   
  */
  A2EXT int A2PAS a2NetLink (int mode, char *name);

  /**
       
    \param KeepName [in] --     NetBios 
     != 0      ,       
    \return 0   
  */
  A2EXT void A2PAS a2NetOff (int KeepName);

# define NKNETWORK(cfgfile) a2NetLink(A2NET_CFGFILE, cfgfile)
# define NKNetOff(ExitCode) a2NetOff(0)
#endif /* H_A2SYSDEF */

#ifdef    H_A2SYSDEF

  /**
    ,        
    \return 0 -- ,  
  */
  A2EXT int A2PAS a2netEnvironment(void);

  /**
         
    \param serverName [in] -- NetBios  TCP/IP  ()  
    \return     ( >= 0)    ( < 0 )
  */
  A2EXT int A2PAS a2netConnect (char *serverName);

  /**
         
    \param channel [in] --    ( #a2netConnect)
    \return 0 -- ,  
  */
  A2EXT int A2PAS a2netDisConnect (int channel);

  /**
     MAC     
    \param mode [in] - 'b' = binary,  = text
    \param network [out] -    (  -  0xFFFFFFFF)
    \param card [out] - MA   (6   12    )
    \return 0 -- ,  
    \note      NetBios
           MAC   
  */
  A2EXT int A2PAS a2netGetAddr (char mode, char *network, char *card);

# define a2NetIPX_Addr a2netGetAddr
#endif /* H_A2SYSDEF */

#if defined(FULL_A2NET00) && !defined(H_A2NIKA)
  int a2netChkChannel (int channel);
  int a2netTstDAbf    (int channel);
# define MAX_N_SERVER  5 /* max number of servers for one station */
# define CH_OPEN       1
  extern int A2NameRegistered;
  int a2netRegister   (char *localName);
  int a2netUnregister (char *name);
  int a2netSend       (int channel, void *data, unsigned datalen);
  int a2netReceive    (int channel, void *buff, unsigned bufflen);
#endif

/**
  \def MAX_N_RES_CLI
     ,    
*/
#ifdef __FOR_DOS__
# define MAX_N_RES_CLI 128
#else
# define MAX_N_RES_CLI 1024
#endif

#ifndef RES_OPEN
# define RES_OPEN  1
# define RES_LOCK  2
# define RES_FIXED 4
#endif

#ifdef H_A2SYSDEF
  /**
       ,     
    \param server [in] -   
    \param name [in] -    15 
    \return     ,   0 -  
    \note     < 16 ,       32 .
                ,  
      ,     > 15 .    
       47 .
  */
  A2EXT long A2PAS a2ResourceOpen  (char *server, char *name);

  /**
     
         1,   0    
    \param hResource [in] -      
    \return   ( < 0)
  */
  A2EXT int  A2PAS a2ResourceClose (long hResource);

# define A2RES_CLOSEALL (-17) ///<      

  /**
      
    \param hResource [in] -      
    \param open [out] -   
    \param lock [out] -   :
     0 = , < 0 =  , > 0 =  
    \return   ( < 0)
  */
  A2EXT int  A2PAS a2ResourceTest (long hResource, int *open, int *lock);

  /**
     
            
    \param hResource [in] -      
    \return   ( < 0)
  */
  A2EXT int A2PAS a2ResourceLock (long hResource);

  /**
      
    \param hResource [in] -      
    \return   ( < 0)
  */
  A2EXT int A2PAS a2ResourceUnlock(long hResource);

  /**
      
    \param hResource [in] -      
    \param type [in] -    
    'c' -- char
    'i' -- int
    'l' -- long
    'f' -- float
    'd' -- double
    's' -- string ( 32 )
    'm' -- memory ( 32 )
    \param buf [out] -    
    \return   ( < 0)
  */
  A2EXT int A2PAS a2ResourceRead  (long hResource, int type, void *buf);

  /**
         
    \param hResource [in] -      
    \param type [in] -   . #a2ResourceRead
    \param buf [in] -       
    \return   ( < 0)
  */
  A2EXT int A2PAS a2ResourceWrite (long hResource, int type, void *buf);

  /**
      
        
    \param ch [in] -   
    \param resnm [in] -  
    \param func [in] -  
     'd' - 
     'l' - 
     'u' - 
     'f' - 
     'r' -   (reset)
    \param prm [in] -  
        'r'    
    \return   ( < 0)
  */
  A2EXT int A2PAS a2ResourceAdmin (int ch,char *resnm,int func,int prm);
#endif /* H_A2SYSDEF */

#ifdef    H_A2SYSDEF
 /**
           
   \param fname [in] -  ,   SERVER:filename
   \return 0 =  
 */
 A2EXT int  A2PAS a2_exist  (char *fname);

 /**
         
   \param fullnm [out] -      
   \param fname [in] -  ,   SERVER:filename
   \param disp [in] -  ,   #a2_open();
   \return 0 =  
 */
 A2EXT int  A2PAS a2_fullnm (char *fullnm, char *fname, char disp);

 /**
     
   \param fname [in] -  ,   SERVER:filename
   \param mode [in] -   (O_RDWR, O_RDONLY, O_WRONLY)
   \return >0 = file handle,  = 
 */
 A2EXT int  A2PAS a2_open   (char *fname, int mode);

 /**
      ( )
   \param fname [in] -  ,   SERVER:filename
   \param mode [in] -  
   \return >0 = file handle,  = 
 */
 A2EXT int  A2PAS a2_creat (char *fname, int mode);

 /**
     (  )
   \param fname [in] -  ,   SERVER:filename
   \return < 0,  
 */
 A2EXT int  A2PAS a2_unlink (char *fname);
 
 /**
       ,   #a2_open()  #a2_creat()
   \param fh [in] -   
   \return < 0,  
 */
 A2EXT int  A2PAS a2_close  (int fh);

 /**
        
   \param fh  [in] -    
   \param buf [out] -    
   \param len [in] -   (  )
   \return >= 0 -   ,  - 
 */
 A2EXT int  A2PAS a2_read (int fh, void *buf, unsigned int len);

 /**
        
   \param fh  [in] -    
   \param buf [in] -     
   \param len [in] -   ( )
   \return >= 0 -   ,  - 
  */
 A2EXT int  A2PAS a2_write (int fh, void *buf, unsigned int len);

 /**
       (  )
   \param fh  [in] -    
   \param fPos [in] - 
   \param mode [in] -   (SEEK_CUR, SEEK_CUR, SEEK_END)
   \return >= 0 -    ,  - 
 */
 A2EXT long A2PAS a2_lseek (int fh, long fPos, int mode);

 /**
      (  )
   \param fh  [in] -  
   \return >= 0 -  ,  - 
 */
 A2EXT long A2PAS a2_filelength (int fh);
#endif /* H_A2SYSDEF */

enum EServerInfoRequests ///     
{
   A2SI_rqMEMFREE,     ///< =0   (long)
   A2SI_rqDISKFREE,    ///< =1     (#A2SI_DFREE)
   A2SI_rqGLOBALINF,   ///< =2   (#A2SI_GLOBALINF)
   A2SI_rqCLIENTS,     ///< =3  (16- )
   A2SI_rqDAFILES,     ///< =4  DA  ("name1" "\0" "name2"...)
   A2SI_rqRESOURCES,   ///< =5   (16- )
   A2SI_rqNNN          ///<   
};

struct a2si_globalinf ///    
{
   short Version;       ///<  
   short Flags;         ///<  : #EServerStateFlags
   short max_Clients;   ///<    
   short act_Clients;   ///<   
   short max_Files;     ///<     
   short act_Files;     ///<    
   short max_Resources; ///<    
   short act_Resources; ///<   
   short max_Processes; ///<     
   short act_Processes; ///<    
   short max_Buffers;   ///<    
   short act_Buffers;   ///<   
   short transWait;     ///<     (1 = 1/18.2 )
   short transIdle;     ///<      
   short blkSz;         ///<  
};
typedef struct a2si_globalinf A2SI_GLOBALINF; ///<    

struct a2si_dfree ///       
{
   short   ndisks; ///<  
   long space[64]; ///< size(A:), size(B:), size(C:) ...
};
typedef struct a2si_dfree A2SI_DFREE; ///<       

#ifdef    H_A2SYSDEF
  /**
        
    \param server [in] -  
    \param psw [in] -  
    \return >= 0 -     (  )
  */
  A2EXT int A2PAS a2_login(char *server, char *psw);

  /**
        
    \param ch [in] -   
    \return >= 0 -    
  */
  A2EXT int A2PAS a2_logout  (int ch);

  /**
      
    \param ch [in] -   
    \param stateFlags [in] -  #EServerStateFlags
    \return >= 0 -    
  */
  A2EXT int A2PAS a2_setstat (int ch, int stateFlags);

  enum EServerStateFlags ///   
  {
    A2SF_ENABLEC   = 1,  ///<   
    A2SF_ASKDOWN   = 2,  ///<     
    A2SF_32BIT     = 4,  ///< 32 bit memory model
    A2SF_WIN32     = 8,  ///< WIN32
    A2SF_HIDE      = 16, ///<  
    A2SF_ICONIC    = 32, ///<    
    A2SF_INVISIBLE = 64, ///<  
    A2SF_STOP      = 15  ///<  
  };

  /**
       
    \param server [in] -  
    \param index [in] -    (#EServerInfoRequests)
    \param buf [out] -     (   \a index)
    \return >= 0 -    
  */
  A2EXT int A2PAS a2netAdmServerInfo (char *server, int index, void *buf);
#endif /* H_A2SYSDEF */

#if !defined(__FOR_WINDOWS__) && !defined(__FOR_WIN32__)
  int a2netDisconAlarm (int seconds);
  int a2netDisconTest (int noShow);
#endif

#if defined(FULL_A2NET00) && !defined(H_A2NIKA)
  int a2netAdmServerList (char *buf, int (*hook)(int ticks, char *name));
#endif

#if defined(SERVER) || defined(FULL_A2NET00)
  typedef struct {
     unsigned short flags, ftime,fdate;
     long                        fsize;
     char            attrib, name[127];
  } A2FF_INFO;
#endif

#if defined(FULL_A2NET00) && !defined(H_A2NIKA)
 int a2_emuscr  (int ch, int Key, char *bf);
 int a2_datime  (int ch, int set, struct a2datetm *pdt);
 int a2_getdisk (int ch);
 int a2_setdisk (int ch, int drive);
 int a2_diskfree(int ch, int drive, unsigned *t_c, unsigned *a_c, long *csz);
 int a2_rddir   (int ch, char *dir);
 int a2_chdir   (int ch, char *dir);
 int a2_mkdir   (int ch, char *dir);
 int a2_rmdir   (int ch, char *dir);
 int a2_rename  (int ch, char *oldname, char *newname);
 int a2_filefind(int ch, int first, char *wildcard, A2FF_INFO *fi, int bsz);
 int a2_getftime(int fh, unsigned *dt, unsigned *tm);
 int a2_setftime(int fh, unsigned  dt, unsigned  tm);
#endif

#ifdef __cplusplus
 }
#endif
#pragma pack (pop)

#endif /*H_A2NET*/
