/**
  \file   a2nika.h
  \brief     a2nika32.dll
  \author  
  \date   13.12.1990
*/

#ifndef   H_A2NIKA
#define   H_A2NIKA
#pragma pack(push, 8)

#ifndef H_A2SYSDEF
# include "a2sysdef.h"
#endif

#ifndef H_A2DIO
# include "a2dio.h"
#endif

#ifndef H_A2TRDEF
# include "a2trdef.h"
#endif

#ifndef H_A2TR
# include "a2tr.h"
#endif

#ifndef H_A2DDT
# include "a2ddt.h"
#endif

#ifndef H_A2ACC
# include "a2acc.h"
#endif

#ifndef H_A2CONV
# include "a2conv.h"
#endif

#ifndef H_A2NET
# include "a2net.h"
#endif

#ifndef H_A2CRYPT
# include "a2crypt.h"
#endif

#ifdef __cplusplus
 extern "C" {
#endif


typedef TREE   *LPTREE;   ///<    
typedef DDT    *LPDDT;    ///<    
typedef ACCESS *LPACCESS; ///<    


/** @defgroup exported_LDSC         LDSC
 */

 /**
   
  \ingroup exported_LDSC
  \param ldsc   LDSC 
  \return NULL,      (  )
*/
A2EXT LPLDSC A2PAS a2ldtxtdl(LPLDSC ldsc);

/**
   
  \ingroup exported_LDSC
  \param src ,   NULL -   == dst
  \param dest ,   NULL -    ( )
  \return    
*/
A2EXT LPLDSC A2PAS a2ldlcpy (LPLDSC src, LPLDSC dest);

/**
      LDSC
  \ingroup exported_LDSC
  \param ldsc   LDSC,    
  \param text C-    
  \param ns   
*/
A2EXT void   A2PAS a2ldtstr (LPLDSC ldsc, LP_CHAR text, int ns);

/**
        LDSC
  \ingroup exported_LDSC
  \param ldsc   LDSC,    
  \param text C-    LDSC
  \return  LDSC,   
*/
A2EXT LPLDSC A2PAS a2ldfstr (LP_CHAR text, LPLDSC ldsc);

/**
     LDSC  C-.
  \ingroup exported_LDSC
  \param reg   
    'c' -     (   ldsc);
    'l' -    ;
    'n' -      ;
    'b' -       ;
    'a' -      
  \param ldsc   LDSC,    
  \param text    
  \result    LDSC
*/
A2EXT LPLDSC A2PAS a2ldadd  (char reg, LPLDSC ldsc, LP_CHAR text);

/**
       LDSC.
  \ingroup exported_LDSC
  \param ldsc   LDSC 
  \return int   
*/
A2EXT int    A2PAS a2ldlen  (LPLDSC ldsc);

/**
       LDSC.
  \ingroup exported_LDSC
  \param ldsc   LDSC 
  \return int   
*/
A2EXT int    A2PAS a2ldltxt (LPLDSC ldsc);

/**
      LDSC
  \ingroup exported_LDSC
  \param text C-    LDSC
  \param ldsc   LDSC,    
  \return  LDSC,   
*/
A2EXT LPLDSC A2PAS a2ldftxt (LP_CHAR text, LPLDSC ldsc);

/**
      LDSC.
      .
  \ingroup exported_LDSC
  \param ldsc   LDSC,    
  \param text C-    
  \param nt   
*/
A2EXT void   A2PAS a2ldttxt (LPLDSC ldsc, LP_CHAR text, int nt);


/** @defgroup exported_TREE      
 */
/**
 *      #TreeV()  #AcsV()
 * \sa TreeV() AcsV()
 * \ingroup exported_TREE
 */
enum ENewVCodes
{
   S_L =255,  ///<    (Save Level)
   G_L =254,  ///<    (Get Level)
   S_GL=253,  ///<    (Save Global Level)
   G_GL=252,  ///<    (Get Global Level)
   S_E0=251,  ///<  
   S_ET=250,  ///<      
   S_ED=249,  ///<       ( )
   D_UK=248,  ///<     (D_K, U_K)
   L_UK=247,  ///<      (D_K, U_K)
   D_WK=246,  ///<     (D_K, W_K)
   L_WK=245,  ///<     (L_K, W_K)
   D_RD=244,  ///<       (D_K, R_D)
   L_RD=243,  ///<     (L_K, R_D)
   D_RV=D_RD, ///< == D_RD
   L_RV=L_RD, ///< == L_RD
   D_WV=242,  ///<     (D_K, W_V)
   L_WV=241,  ///<     (L_K, W_V)
   D_UV=240,  ///<     (D_K, U_V)
   L_UV=239,  ///<     (L_K, U_V)
   r_TR=238,  ///<    
   w_TR=237,  ///<    
   R_TR=236,  ///<      
   W_TR=235,  ///<      
   C_DR=234   ///<      != 0 (Conditional D_R)
};

/**
 *         
 * \sa TreeV() AcsV() ENewVCodes
 * \ingroup exported_TREE
 */
#define ACTY(ac,ty) ((ac) | ((ty) << 8))

/**
    ( )
  \ingroup exported_TREE
  \param perr [out] -         [#EDAErrcodes, #ETreeErrcodes]
  \param fname [in] -   
  \param disp [in] -  
   'r' -   ;
   'g' -       PATH;
   'o' -   /;
   'u' -     /;
   'c' -   (  - );
   's' -  (    );
          #EDAOpen_Flags
  return      #TREE,  NULL   
*/
A2EXT LPTREE A2PAS TreeOpen (LP_INT perr, LP_CHAR fname, int disp);

/**
    ( )
  \ingroup exported_TREE
  \param perr [out] -         [#EDAErrcodes, #ETreeErrcodes]
  \param fname [in] -   
  \param disp [in] - . #TreeOpen()
  \param s [in] -       [#a2dioSubscribeSet]
  \param tout [in] -   ,   0
  return      #TREE,  NULL   
*/
A2EXT LPTREE A2PAS TreeOpenEx (LP_INT perr, LP_CHAR fname, int disp, a2dioSubscribeSet* s, unsigned tout);

/**
       #TreeOpen(), #TreeOpenEx()
  \ingroup exported_TREE
  \param pt [in] -     #TREE
  \return 0    [#EDAErrcodes, #ETreeErrcodes]
*/
A2EXT int  A2PAS TreeClose (LPTREE pt);

/**
     
  \ingroup exported_TREE
  \param pt [in] -     #TREE
  \param on [in] - 0 = ,  = 
  \return 0    [#EDAErrcodes, #ETreeErrcodes]
*/
A2EXT int  A2PAS TreeSJ (LPTREE pt, int on);

/**
           [(#D_K,#U_V),...]
  \ingroup exported_TREE
  \param pt [in] -     #TREE
  \param mv [in] -   [#EMoveActionCodes]
  \param op [in] -   [#EMoveActionCodes]
  \param tk [in] -   [#ENikaDataTypes]
  \param pk [in,out] -    
  \param td [in] -   [#ENikaDataTypes]
  \param pd [in,out] -    
  \return 0    [#EDAErrcodes, #ETreeErrcodes]
*/
A2EXT int A2PAS TreeSKD(LPTREE pt, int mv,int op, int tk,LP_VOID pk,int td,LP_VOID pd);

/**
          [(#L_K,#U_K),...]
  \ingroup exported_TREE
  \param pt [in] -     #TREE
  \param mv [in] -   [#EMoveActionCodes]
  \param op [in] -   [#EMoveActionCodes]
  \param tk [in] -   [#ENikaDataTypes]
  \param pk [in,out] -    
  \return 0    [#EDAErrcodes, #ETreeErrcodes]
*/
A2EXT int A2PAS TreeSK (LPTREE pt, int mv,int op, int tk,LP_VOID pk);

/**
          [(#D_F,#R_D),...]
  \ingroup exported_TREE
  \param pt [in] -     #TREE
  \param mv [in] -   [#EMoveActionCodes]
  \param op [in] -   [#EMoveActionCodes]
  \param td [in] -   [#ENikaDataTypes]
  \param pd [in,out] -    
  \return 0    [#EDAErrcodes, #ETreeErrcodes]
*/
A2EXT int A2PAS TreeSD (LPTREE pt, int mv,int op, int td,LP_VOID pd);

/**
          [(#U_S,#N_A) (#S_O,#D_V),...]
  \ingroup exported_TREE
  \param pt [in] -     #TREE
  \param mv [in] -   [#EMoveActionCodes]
  \param op [in] -   [#EMoveActionCodes]
  \return 0    [#EDAErrcodes, #ETreeErrcodes]
*/
A2EXT int A2PAS TreeS  (LPTREE pt, int mv,int op);

/**
       
  \note   
  \ingroup exported_TREE
  \param pt [in] -     #TREE
  \param lvl [in] -   
   newLevel = (lvl < 0) ? currLevel + lvl : lvl
  \return  
*/
A2EXT int A2PAS TreeSLVL (LPTREE pt, int lvl);

/**
       
  \note   
  \ingroup exported_TREE
  \param pt [in] -     #TREE
  \param lvl [in] -   
   newLevel = (lvl < 0) ? currLevel + lvl : lvl
  \return  
*/
A2EXT int A2PAS TreeSGLVL(LPTREE pt, int lvl);

/**
   
  \ingroup exported_TREE
  \param op [in] -  
   #C_V -    ,
   #C_D -     ;
   #M_V  -    ;
   #CM_D -     ;
  \param pt1 [in] -       
  \param ppt2 [in] -       [LPTREE]
        [LPTREE*] (   #TREE)
  \return 0    [#EDAErrcodes, #ETreeErrcodes]
*/
A2EXT int A2PAS TreeCPY (int op, LPTREE pt1, LP_VOID ppt2);

/**
     
  \ingroup exported_TREE
  \param pt1 [in] -       #TREE
  \param ppt2 [out] -            
  \return 0    [#EDAErrcodes, #ETreeErrcodes]
*/
A2EXT int A2PAS TreeDUP (LPTREE pt1, LPTREE *ppt2);

/**
    
  \ingroup exported_TREE
  \param pt1 [in] -      #TREE
  \param ppt2 [out] -       ,
      NULL
  \return 0    [#EDAErrcodes, #ETreeErrcodes]
*/
A2EXT int A2PAS TreeDLT (LPTREE pt1, LPTREE *ppt2);

/**
       
  \ingroup exported_TREE
  \param pt [in] -     #TREE
  \return 0    [#EDAErrcodes, #ETreeErrcodes]
*/
A2EXT int A2PAS TreeSAV (LPTREE pt);

/**
        
  \ingroup exported_TREE
  \param pt [in] -     #TREE
  \return 0    [#EDAErrcodes, #ETreeErrcodes]
*/
A2EXT int A2PAS TreeRST (LPTREE pt);

/**
    (Check Point)
       
  \note    
  \ingroup exported_TREE
  \param pt [in] -     #TREE
  \return 0    [#EDAErrcodes, #ETreeErrcodes]
*/
A2EXT int A2PAS TreeCP  (LPTREE pt);

/**
      
      (_[, ],...)
  0        .
  \ingroup exported_TREE
  \param pt [in] -     #TREE
  \param p1 [in] -      
  \return 0    [#EDAErrcodes, #ETreeErrcodes]
  \sa #EMoveActionCodes, #ENewVCodes, #ACTY
*/
A2EXT int A2EXP TreeV (LPTREE pt, int p1, ...);

/**
    
  tr3 = tr1 & tr2 ( tr3 == NULL: tr1 &= tr2)
  \ingroup exported_TREE
  \param Flag [in] -  ,   0
  \param tr1 [in] -    #TREE  
  \param tr2 [in] -    #TREE  
  \param tr3 [in] -    #TREE ,  NULL
  \param vSc [out] -          
  \return 0    [#EDAErrcodes, #ETreeErrcodes]
*/
EXTERNFUNC int EXPORTFUNC a2TreeCros (
   int Flag, LPTREE tr1, LPTREE tr2, LPTREE tr3, unsigned long *vSc
);

/**
    
  tr3 = tr1 - tr2 ( tr3 == NULL: tr1 -= tr2)
  \ingroup exported_TREE
  \param Flag [in] -  ,   0
  \param tr1 [in] -    #TREE  
  \param tr2 [in] -    #TREE  
  \param tr3 [in] -    #TREE ,  NULL
  \param vSc [out] -          
  \return 0    [#EDAErrcodes, #ETreeErrcodes]
*/
EXTERNFUNC int EXPORTFUNC a2TreeSub (
   int Flag, LPTREE tr1, LPTREE tr2, LPTREE tr3, unsigned long *vSc
);

/**
    
  tr3 = tr1 + tr2 ( tr3 == NULL: tr1 += tr2)
  \ingroup exported_TREE
  \param Flag [in] -  ,   0
  \param tr1 [in] -    #TREE  
  \param tr2 [in] -    #TREE  
  \param tr3 [in] -    #TREE ,  NULL
  \param vSc [out] -          
  \return 0    [#EDAErrcodes, #ETreeErrcodes]
*/
EXTERNFUNC int EXPORTFUNC a2TreeAdd (
   int Flag, LPTREE tr1, LPTREE tr2, LPTREE tr3, unsigned long *vSc
);

#define TreeCros a2TreeCros
#define TreeSub  a2TreeSub
#define TreeAdd  a2TreeAdd


/** @defgroup exported_ACS      
 */
/**
     ( )
  \ingroup exported_ACS
  \param perr [out] -         [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes, #EAcsErrcodes]
  \param fdod [in] -      
  \param ftre [in] -    
  \param disp [in] -  , . #TreeOpen()
  return      #ACCESS,  NULL   
*/
A2EXT LPACCESS A2PAS AcsOpen (LP_INT perr,LP_CHAR fdod,LP_CHAR ftre,int disp);

/**
     ( )
  \ingroup exported_ACS
  \param perr [out] -         [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes, #EAcsErrcodes]
  \param fdod [in] -      
  \param ftre [in] -    
  \param disp [in] -  , . #TreeOpen()
  \param s [in] -       [#a2dioSubscribeSet]
  \param tout [in] -   ,   0
  return      #ACCESS,  NULL   
*/
A2EXT LPACCESS A2PAS AcsOpenEx (LP_INT perr,LP_CHAR fdod,LP_CHAR ftre,int disp,a2dioSubscribeSet* s, unsigned tout);

/**
   
  \ingroup exported_ACS
  \param pacc [in] -     #ACCESS
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes, #EAcsErrcodes]
*/
A2EXT int A2PAS AcsClose (LPACCESS pacc);

/**
     
  \ingroup exported_ACS
  \param pacc [in] -     #ACCESS
  \param on [in] - 0 = ,  = 
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes, #EAcsErrcodes]
*/
A2EXT int  A2PAS AcsSJ (LPACCESS pacc, int on);

/**
           [(#D_K,#U_V),...]
  \ingroup exported_ACS
  \param pa [in] -     #ACCESS
  \param mv [in] -   [#EMoveActionCodes]
  \param op [in] -   [#EMoveActionCodes]
  \param tk [in] -   [#ENikaDataTypes]
  \param pk [in,out] -    
  \param td [in] -   [#ENikaDataTypes]
  \param pd [in,out] -    
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes, #EAcsErrcodes]
*/
A2EXT int A2PAS AcsSKD(LPACCESS pa, int mv,int op, int tk,LP_VOID pk, int td,LP_VOID pd);

/**
          [(#L_K,#U_K),...]
  \ingroup exported_ACS
  \param pa [in] -     #ACCESS
  \param mv [in] -   [#EMoveActionCodes]
  \param op [in] -   [#EMoveActionCodes]
  \param tk [in] -   [#ENikaDataTypes]
  \param pk [in,out] -    
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes, #EAcsErrcodes]
*/
A2EXT int A2PAS AcsSK (LPACCESS pa, int mv,int op, int tk,LP_VOID pk);

/**
          [(#D_F,#R_D),...]
  \ingroup exported_ACS
  \param pa [in] -     #ACCESS
  \param mv [in] -   [#EMoveActionCodes]
  \param op [in] -   [#EMoveActionCodes]
  \param td [in] -   [#ENikaDataTypes]
  \param pd [in,out] -    
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes, #EAcsErrcodes]
*/
A2EXT int A2PAS AcsSD (LPACCESS pa, int mv,int op, int td,LP_VOID pd);

/**
          [(#U_S,#N_A) (#S_O,#D_V),...]
  \ingroup exported_ACS
  \param pacc [in] -     #ACCESS
  \param mv [in] -   [#EMoveActionCodes]
  \param op [in] -   [#EMoveActionCodes]
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes, #EAcsErrcodes]
*/
A2EXT int A2PAS AcsS  (LPACCESS pacc, int mv,int op);

/**
      
  \note   
  \ingroup exported_ACS
  \param pacc [in] -     #ACCESS
  \param lvl [in] -   
   newLevel = (lvl < 0) ? currLevel + lvl : lvl
  \return  
*/
A2EXT int A2PAS AcsSLVL (LPACCESS pacc, int lvl);

/**
       
  \note   
  \ingroup exported_ACS
  \param pacc [in] -     #ACCESS
  \param lvl [in] -   
   newLevel = (lvl < 0) ? currLevel + lvl : lvl
  \return  
*/
A2EXT int A2PAS AcsSGLVL(LPACCESS pacc, int lvl);

/**
   
  \ingroup exported_ACS
  \param op [in] -  
   #C_V -    ,
   #C_D -     ;
   #M_V  -    ;
   #CM_D -     ;
  \param pacc1 [in] -     #ACCESS
  \param ppacc2 [in] -       [LPACCESS]
        [LPACCESS*] (   #ACCESS)
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes, #EAcsErrcodes]
*/
A2EXT int A2PAS AcsCPY (int op, LPACCESS pacc1, LP_VOID ppacc2);

/**
     
  \note    
  \ingroup exported_ACS
  \param pacc1 [in] -     #ACCESS
  \param ppacc2 [out] -        
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes, #EAcsErrcodes]
*/
A2EXT int A2PAS AcsDUP (LPACCESS pacc1, LPACCESS *ppacc2);

/**
   
  \ingroup exported_ACS
  \param pacc1 [in] -      #ACCESS
  \param ppacc2 [out] -       ,
      NULL
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes, #EAcsErrcodes]
*/
A2EXT int A2PAS AcsDLT (LPACCESS pacc1, LPACCESS *ppacc2);

/**
      
  \ingroup exported_ACS
  \param pacc [in] -     #ACCESS
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes, #EAcsErrcodes]
*/
A2EXT int A2PAS AcsSAV (LPACCESS pacc);

/**
      
  \ingroup exported_ACS
  \param pacc [in] -     #ACCESS
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes, #EAcsErrcodes]
*/
A2EXT int A2PAS AcsRST (LPACCESS pacc);

/**
     
  \ingroup exported_ACS
  \param pacc [in] -     #ACCESS
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes, #EAcsErrcodes]
*/
A2EXT int A2PAS AcsCP  (LPACCESS pacc);

/**
    
  \ingroup exported_ACS
  \param paccSrc [in] -     #ACCESS 
  \param paccDst [in] -     #ACCESS 
  \param IgnErr [in] -  != 0 -   
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes, #EAcsErrcodes]
*/
A2EXT int A2PAS AcsCopy(LPACCESS paccSrc, LPACCESS paccDst, int IgnErr);

/**
      
      (_[, ],...)
  0        .
  \ingroup exported_ACS
  \param pacc [in] -     #ACCESS
  \param p1 [in] -      
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes, #EAcsErrcodes]
*/
A2EXT int A2EXP AcsV (LPACCESS pacc, int p1, ...);

/** @defgroup exported_DOD      
 */
/**
       ( )
  \ingroup exported_DOD
  \param perr [out] -         [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes]
  \param fdod [in] -      
  \param disp [in] -  , . #TreeOpen()
  return      #ACCESS,  NULL   
*/
A2EXT LPDDT A2PAS DodOpen (LP_INT perr, LP_CHAR fdod, int disp);

/**
       ( )
  \ingroup exported_DOD
  \param perr [out] -         [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes]
  \param fdod [in] -      
  \param disp [in] -  , . #TreeOpen()
  \param tout [in] -   ,   0
  return      #ACCESS,  NULL   
*/
A2EXT LPDDT A2PAS DodOpenEx (LP_INT perr, LP_CHAR fdod, int disp, unsigned tout);

/**
     
  \ingroup exported_DOD
  \param pddt [in] -     #DDT
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes]
*/
A2EXT int   A2PAS DodClose (LPDDT pddt);

/**
            [(#D_K,#U_V),...],
    
  \ingroup exported_DOD
  \param pddt [in] -     #DDT
  \param mv [in] -   [#EMoveActionCodes]
  \param op [in] -   [#EMoveActionCodes]
  \param tk [in] -   [#ENikaDataTypes]
  \param pk [in,out] -    
  \param td [in] -  
   'a' -   #DDTINF,
   'n' -  ldsc  ,
   't' -  ldsc   ,
   'x' -    ddtdata;
  \param pd [in,out] -    
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes]
*/
A2EXT int A2PAS DodSWKD(LPDDT pddt,int mv,int op,int tk,LP_VOID pk,int td,LP_VOID pd);

/**
           [(#L_K,#U_K),...],
    
  \ingroup exported_DOD
  \param pddt [in] -     #DDT
  \param mv [in] -   [#EMoveActionCodes]
  \param op [in] -   [#EMoveActionCodes]
  \param tk [in] -   [#ENikaDataTypes]
  \param pk [in,out] -    
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes]
*/
A2EXT int A2PAS DodSWK (LPDDT pddt,int mv,int op,int tk,LP_VOID pk);

/**
           [(#D_F,#R_D),...],
    
  \ingroup exported_DOD
  \param pddt [in] -     #DDT
  \param mv [in] -   [#EMoveActionCodes]
  \param op [in] -   [#EMoveActionCodes]
  \param td [in] -  : . #DodSWKD()
  \param pd [in,out] -    
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes]
*/
A2EXT int A2PAS DodSWD (LPDDT pddt,int mv,int op,int td,LP_VOID pd);

/**
          [(#U_S,#N_A) (#S_O,#D_V),...],
    
  \ingroup exported_DOD
  \param pddt [in] -     #DDT
  \param mv [in] -   [#EMoveActionCodes]
  \param op [in] -   [#EMoveActionCodes]
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes]
*/
A2EXT int A2PAS DodSW  (LPDDT pddt,int mv,int op);

/**
            [(#D_K,#U_V),...],
    
  \ingroup exported_DOD
  \param pddt [in] -     #DDT
  \param mv [in] -   [#EMoveActionCodes]
  \param op [in] -   [#EMoveActionCodes]
  \param tk [in] -   [#ENikaDataTypes]
  \param pk [in,out] -    
  \param td [in] -  : . #DodSWKD()
  \param pd [in,out] -    
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes]
*/
A2EXT int A2PAS DodSRKD(LPDDT pddt,int mv,int op,int tk,LP_VOID pk,int td,LP_VOID pd);

/**
           [(#L_K,#U_K),...],
    
  \ingroup exported_DOD
  \param pddt [in] -     #DDT
  \param mv [in] -   [#EMoveActionCodes]
  \param op [in] -   [#EMoveActionCodes]
  \param tk [in] -   [#ENikaDataTypes]
  \param pk [in,out] -    
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes]
*/
A2EXT int A2PAS DodSRK (LPDDT pddt,int mv,int op,int tk,LP_VOID pk);

/**
           [(#D_F,#R_D),...],
    
  \ingroup exported_DOD
  \param pddt [in] -     #DDT
  \param mv [in] -   [#EMoveActionCodes]
  \param op [in] -   [#EMoveActionCodes]
  \param td [in] -  : . #DodSWKD()
  \param pd [in,out] -    
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes]
*/
A2EXT int A2PAS DodSRD (LPDDT pddt,int mv,int op,int td,LP_VOID pd);

/**
          [(#U_S,#N_A) (#S_O,#D_V),...],
    
  \ingroup exported_DOD
  \param pddt [in] -     #DDT
  \param mv [in] -   [#EMoveActionCodes]
  \param op [in] -   [#EMoveActionCodes]
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes]
*/
A2EXT int A2PAS DodSR (LPDDT pddt,int mv,int op);

/**
   
  \ingroup exported_DOD
  \param op [in] -  
   #C_V -    ,
   #C_D -     ;
  \param pd1 [in] -     #DDT 
  \param pd2 [in] -     #DDT [LPDDT*]
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes]
*/
A2EXT int A2PAS DodCPY (int op,LPDDT pd1,LPDDT *pd2);

/**
     
  \ingroup exported_DOD
  \param pd1 [in] -     #DDT
  \param ppd2 [out] -        
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes]
*/
A2EXT int A2PAS DodDUP (LPDDT pd1, LPDDT *ppd2);

/**
   
  \ingroup exported_DOD
  \param pd1 [in] -     #DDT
  \param ppd2 [out] -       ,
      NULL
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes]
*/
A2EXT int A2PAS DodDLT (LPDDT pd1, LPDDT *ppd2);

/**
      
  \ingroup exported_DOD
  \param pd [in] -     #DDT
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes]
*/
A2EXT int A2PAS DodSAV (LPDDT pd);

/**
      
  \ingroup exported_DOD
  \param pd [in] -     #DDT
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes]
*/
A2EXT int A2PAS DodRST (LPDDT pd);

/**
      
  \note    
  \ingroup exported_DOD
  \param pd [in] -     #DDT
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes]
*/
A2EXT int A2PAS DodCP  (LPDDT pd);

/**
          
  \ingroup exported_DOD
  \param perr [out] -       
  \param pddt [in] -     #DDT
  \param pkey [in] -    
  \param usk [in] -   
  \return   #TREE -   
*/
A2EXT LPTREE A2PAS DodUSet (LP_INT perr, LPDDT pddt, long *pkey, long usk);

/**
     ,  #DodUSet()
  \ingroup exported_DOD
  \param pt [in] -     #TREE [ #DodUSet()]
  \param pd [in] -     #DDT [     #DodUSet()]
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes]
*/
A2EXT int A2PAS DodURet (LPTREE pt, LPDDT pd);

/**
    
  \ingroup exported_DOD
  \param pddt [in] -     #DDT
  \param TopLvl [in] -     () 
   >= 0 -   , < 0 -  =  + \a TopLvl
  \param IdxName [in] -  
  \param AtrTxtName [in] -   
  \param mode [in] -  ,  0
  \return 0    [#EDAErrcodes, #ETreeErrcodes, #EDdtErrcodes]
*/
A2EXT int A2PAS DodAttr (LPDDT pddt, long TopLvl, char *IdxName, char *AtrTxtName, char mode);

#if defined(__FOR_WINDOWS__) || defined(__FOR_WIN32__)
/**
    
 \param pstr    
*/
 A2EXT void A2PAS a2Trace (LPSTR pstr);
#endif

#ifdef __cplusplus
 }
#endif

#pragma pack (pop)
#endif /* H_A2NIKA */
