/**
  \file   a2print.h
  \brief   
  \author  
  \date   13.12.1990
*/
#pragma pack(push, 8)

/*--- a2print.h - head file for programs of printing ------*/
#define A2PRINT_H
#include "a2tvdef.h"          /* TINT, LDSC, WCB, PCB, DOC */
/*-------- parameters for programs of fulfillment ---------*/
typedef struct
        {DOC *doc;
         PCB *pcb;
         ULCB *ulcb;
        } PRTPARM;
/*---------------------------------------------------------*/
#ifdef __cplusplus
extern "C" {
#endif
/*----------- a2print - printing of part ------------------*/
int a2print(PCB *pcb, char *stream);
/*-------- a2mprint - printing of model part --------------*/
int a2mprint(PCB *pcb, char *mname, char *stream);
/*---- a2prpart - printing of document part ---------------*/
int a2prpart(DOC *doc, char *pname, char *stream, int (*f)(PRTPARM *));
/* doc-document descriptor; pname-part name; stream - flow */
/* name or NULL (to document flow, given in a2tvdr);       */
/* f - fulfillment program, structure PRTPARM is transferred*/
/*-- a2setpart - set fulfillment function for part --------*/
int a2setpart(DOC *doc, char *pname, int (*f)(PRTPARM *), int type);
/* doc - document description table; pname  - part name;   */
/* f - fulfillment func. for part windows; type - part type */
/* TP_PH - page header, TP_PF - page end.                  */
/*----- a2prspsz - set sizes of flow page -----------------*/
int a2prspsz(int szpg, char *stream);
/* szpg - required size; stream - flow name;               */
/*----- a2prgpsz - read sizes of flow page ----------------*/
int a2prgpsz(char *stream);
/* stream - flow name; returns page number or -1           */

/*------- a2PrintBuf - out buffer of document -------------*/
int a2PrintBuf(DOC *doc, char *stream) ;
/* doc-document descriptor; stream - flow name or NULL     */
/* (to document flow, given in a2tvdr);                    */

#define  PRINT_HF_ONLY_P   0x01
#define  NOPRINT_HF_LVL1   0x02
int a2SetRegimPrintNewPage(int regim) ;
/* return old regim. regim ::= 0 | PRINT_HF_ONLY_P -       */
/* printed PageHeader and PageFoot only between two periods*/
#ifndef _A2TVDR_F
#define _A2TVDR_F
#define  DC_PRT  0x02
#define  DC_COR  0x04
/*--- a2tvdr - read document from data tree for printing --*/
DOC *a2tvdr(int *err, void *ptree, char *dname, char *stream);
/*err - an entry  value defines parts sequence and takes   */
/* values DC_COR - by coordinates; DC_PRT - by part attributes*/
/* (headers, periods, totals); else by part names;         */
/*ptree - pointer to file of models; dname - document name;*/
/* stream - flow name or NULL (page counters don't reset,  */
/* document doesn't associate with flow during loading     */
#endif
#define    MAX_ESC 40

typedef struct
{   int    countESC ;   //   ESC 
    char   *esc[MAX_ESC]   ;   //  ESC 
} DEFPRT ;

DEFPRT *setDefPrt(DEFPRT *defPrt) ;
#ifdef __cplusplus
}
#endif
/*---------------------------------------------------------*/
#pragma pack (pop)
