/**
  \file   a2str.h
  \brief      
  \author  
  \date   13.12.2000
*/

#ifndef H_A2STR_H
#pragma pack (push, 8)

#ifndef USE_WA_MACROS_ONLY
# define H_A2STR_H
#ifdef __cplusplus
 extern "C" {
#endif

 int  a2isalpha (int c);
 int  a2islower (int c);
 int  a2isupper (int c);
 int  a2tolower (int c);
 int  a2toupper (int c);
 int  a2charcmp (int c1, int c2);
 int  a2charicmp(int c1, int c2);
 char *a2strlwr (char *s);
 char *a2strupr (char *s);
 int  a2strcmp  (const char *s1, const char *s2);
 int  a2stricmp (const char *s1, const char *s2);
 int  a2strnicmp(const char *s1, const char *s2, int n);
 int  a2memcmp  (const char *s1, const char *s2, int n);
 int  a2memicmp (const char *s1, const char *s2, int n);

 A2EXT int A2PAS a2ltrim(char *s); ///<    
 A2EXT int A2PAS a2rtrim(char *s); ///<    
 A2EXT int A2PAS a2trim (char *s); ///<        

 /**
      
 */
 enum enum_A2CODE
 {
   A2CODE_DOS = 0, ///< DOS 866
   A2CODE_WIN = 1, ///< Windows 1251
   A2CODE_KOI = 2, ///< KOI-8R
   A2CODE_NNN      ///<  
 };

 A2EXT int A2PAS a2xlat (int iCodeSrc,const char *src, int iCodeDst,char *dst);
 A2EXT int A2PAS a2code (int iAppCode);

#ifdef __cplusplus
 }
#endif
#endif /*USE_WA_MACROS_ONLY*/

#if defined(USE_WA_MACROS) || defined(USE_WA_MACROS_ONLY) || !defined(H_A2NIKA)
/* Windows(1251) -> DOS(866) char conversion macros (russian letters only) */

/** 1  \a   \a lo  \a hi,  0 (RAnge) */
# define RA_(lo,hi,c) ((int)(unsigned char)(c) >= 0x##lo && (int)(unsigned char)(c) <= 0x##hi)

/**  Win>>DOS    */
# define WA_(c) (char)(      \
    RA_(C0,EF,c) * (c-0x40)+ \
    RA_(F0,FF,c) * (c-0x10)+ \
    RA_(A8,A8,c) * 0xF0    + \
    RA_(B8,B8,c) * 0xF1    + \
    (!(RA_(C0,EF,c) || RA_(F0,FF,c) || RA_(A8,A8,c) || RA_(B8,B8,c))) * c \
  )
# define WA2(a,b)               WA_(a),WA_(b)                                                  ///< Win>>DOS 2 
# define WA3(a,b,c)             WA_(a),WA_(b),WA_(c)                                           ///< Win>>DOS 3 
# define WA4(a,b,c,d)           WA_(a),WA_(b),WA_(c),WA_(d)                                    ///< Win>>DOS 4 
# define WA5(a,b,c,d,e)         WA_(a),WA_(b),WA_(c),WA_(d),WA_(e)                             ///< Win>>DOS 5 
# define WA6(a,b,c,d,e,f)       WA_(a),WA_(b),WA_(c),WA_(d),WA_(e),WA_(f)                      ///< Win>>DOS 6 
# define WA7(a,b,c,d,e,f,g)     WA_(a),WA_(b),WA_(c),WA_(d),WA_(e),WA_(f),WA_(g)               ///< Win>>DOS 7 
# define WA8(a,b,c,d,e,f,g,h)   WA_(a),WA_(b),WA_(c),WA_(d),WA_(e),WA_(f),WA_(g),WA_(h)        ///< Win>>DOS 8 
# define WA9(a,b,c,d,e,f,g,h,i) WA_(a),WA_(b),WA_(c),WA_(d),WA_(e),WA_(f),WA_(g),WA_(h),WA_(i) ///< Win>>DOS 9 

# define G11(c) G_TABLE(c, 0xDA,0xC2,0xBF, 0xC3,0xC5,0xB4, 0xC0,0xC1,0xD9, 0xC4,0xB3) /**  v1x1h */
# define G12(c) G_TABLE(c, 0xD5,0xD1,0xB8, 0xC6,0xD8,0xB5, 0xD4,0xCF,0xBE, 0xCD,0xB3) /**  v1x2h */
# define G21(c) G_TABLE(c, 0xD6,0xD2,0xB7, 0xC7,0xD7,0xB6, 0xD3,0xD0,0xBD, 0xC4,0xBA) /**  v2x1h */
# define G22(c) G_TABLE(c, 0xC9,0xCB,0xBB, 0xCC,0xCE,0xB9, 0xC8,0xCA,0xBC, 0xCD,0xBA) /**  v2x2h */

/**   -     */
# define G_TABLE(c, g7,g8,g9, g4,g5,g6, g1,g2,g3, g0,gD) (char)(\
     g7 * (c==7 || c=='7' || c=='r')           + \
     g8 * (c==8 || c=='7' || c=='T')           + \
     g9 * (c==9 || c=='9')                     + \
     g4 * (c==4 || c=='4')                     + \
     g5 * (c==5 || c=='5' || c=='+' || c=='#') + \
     g6 * (c==6 || c=='6')                     + \
     g1 * (c==1 || c=='1' || c=='L')           + \
     g2 * (c==2 || c=='2')                     + \
     g3 * (c==3 || c=='3')                     + \
     g0 * (c==0 || c=='0' || c=='-' || c=='=') + \
     gD * (c==10|| c=='.' || c=='|' || c=='!')\
  )

/**  Block(density: 0..4) */
# define GB(c) (char)(\
     0x20 * (c<=0) + \
     0xB0 * (c==1) + \
     0xB1 * (c==2) + \
     0xB2 * (c==3) + \
     0xDB * (c>=4)\
  )
  
/**  Half Block(Side: Bottom, Top, Left, Rigt) */
# define GH(c) G_SIDE(c, 0xDC,0xDF,0xDD,0xDE)

/**  Arrows(Side: Down, Up, Left, Rigt) */
# define GA(c) G_SIDE(c, 0xDC,0xDF,0xDD,0xDE)

/**     */
# define G_SIDE(c, gD,gU,gL,gR) (char)(\
     gD * (c=='v' || c=='b' || c=='B' || c==2 || c=='d' || c=='D') + \
     gU * (c=='^' || c=='t' || c=='T' || c==8 || c=='u' || c=='U') + \
     gL * (c=='<' || c=='l' || c=='L' || c==4) + \
     gR * (c=='>' || c=='r' || c=='R' || c==6)\
  )

#endif /* USE_WA_MACROS... */

#pragma pack (pop)
#endif /* H_A2STR_H */

