/**
  \file   a2sysdef.h
  \brief     ,     
  \author  
  \date   13.12.1990
*/

#ifndef H_A2SYSDEF
#define H_A2SYSDEF
#pragma pack (push, 8)

#if defined(_Windows) || defined(_WINDOWS) || defined(WIN32) || defined(_WIN32) || defined(__WIN32__)
# if !defined(__DPMI16__) && !defined(__DPMI32__)
#  if defined(__WIN32__) || defined(WIN32) || defined(_WIN32)
#   define __FOR_WIN32__
#  else
#   define __FOR_WINDOWS__
#  endif
# else
#  ifdef __DPMI32__
#   define __FOR_DPMI32__
#  else
#   define __FOR_DPMI16__
#  endif
# endif
#else
# define __FOR_DOS__
#endif

#if defined(__FOR_WIN32__) || defined(__FOR_DPMI32__) || defined(__FOR_WINDOWS__)
# if defined(_CONSOLE) || (defined(__CONSOLE__) && !defined(NO_CONSOLE)) || defined(EMU_CONSOLE)
#  define __CONS_TV__
# endif
# if !defined(__CONS_TV__) || (defined(SERVER) && !defined(EMU_CONSOLE))
#  define __STRIP_TV__
# endif
#endif

#if defined(__FOR_WIN32__) && defined(__CONS_TV__) && !defined(SERVER)
# define __XLAT_FILENAMES__ 1
#endif

/* Intel x86 */
#define A2_FIRST_LOBYTE

/* Motorola  */
/* #define A2_FIRST_HIBYTE */

#ifdef A2_FIRST_LOBYTE
# define A2_SHORT_C2(c1,c2) (short)((c1)+(c2)*256)
#else
# define A2_SHORT_C2(c1,c2) (short)((c1)*256+(c2))
#endif

#ifdef __BORLANDC__
# pragma warn -8080 /* declared but never used */
# pragma warn -8098  /* Multi-char character    */
#endif

#if defined(_Windows) || defined(_WINDOWS) || defined(WIN32) || defined(_WIN32) || defined(__WIN32__)
# ifndef __WINDOWS_H
#  ifndef _INC_WINDOWS
#   if (_MSC_VER >= 800)
#    pragma warning (disable: 4115 4201 4214)
#    pragma warning (disable: 4305 4514 4711)
#   endif
#   if defined(__BORLANDC__) && __BORLANDC__ >= 0x0570 /* BC++ 2007 */
#    pragma warn -8019 /* code has no effect (winnt.h) */
#   endif
#   define STRICT 1
#   define WIN32_MEAN_AND_LEAN
#   include <windows.h>
#   if (_MSC_VER >= 800)
#    if defined(_DEBUG)
#     pragma warning (disable: 4127)
#     include <crtdbg.h>
#    endif
#    pragma warning (default: 4115 4201 4214)
#   endif
#   if defined(__BORLANDC__) && __BORLANDC__ >= 0x0570 /* BC++ 2007 */
#    pragma warn +8019 /* code has no effect (winnt.h) */
#   endif
#  endif
# endif
#else
  typedef unsigned char  BYTE;
  typedef unsigned short WORD;
  typedef unsigned long  DWORD;
#endif

#ifndef __STDIO_H
# ifndef __STDIO_DEF_
#  ifndef _INC_STDIO
#   include <stdio.h>
#  endif
# endif
#endif

#ifdef __WATCOMC__
# include <stddef.h>
#endif

#if defined(__FOR_WINDOWS__) || defined(__FOR_WIN32__)
#  ifdef NODLL
#    define A2EXP
#    define EXPORTFUNC
#    define EXTERNFUNC
#  else
#    if (_MSC_VER > 800)
#      ifndef H_A2NIKA
#        define EXPORTFUNC __declspec(dllexport)
#      else
#        define EXPORTFUNC __declspec(dllimport)
#      endif
#      define A2EXP EXPORTFUNC
#    else
#      define A2EXP _export
#      define EXPORTFUNC FAR PASCAL _export
#    endif
#    define EXTERNFUNC extern
#  endif
#  define A2CALLBACK CALLBACK
#else
#  define A2EXP
#  define EXPORTFUNC
#  define EXTERNFUNC
#  ifdef __FOR_DOS__
#    define FAR far
#  endif
#  define A2CALLBACK
#endif

#if defined(__FOR_WINDOWS__) || defined(__FOR_WIN32__)
# define A2EXT EXTERNFUNC
# define A2PAS EXPORTFUNC
#else
# define A2EXT
# define A2PAS pascal
#endif

#ifdef __BORLANDC__
# ifndef _DEBUG
#  pragma warn -8080 /* declared but never used */
# endif
#endif

/*------------------------------------------------------------------*/
/*---------------------------- T Y P E S ---------------------------*/
/*------------------------------------------------------------------*/
#pragma pack (push, 1)

struct a2datetm  ///   
{
   short year;   ///< 
   short month;  ///< 
   short day;    ///<   (1-based)
   short hour;   ///< 
   short minute; ///< 
   short second; ///< 
};

#pragma pack (pop)

typedef void *LP_VOID; ///<   void
typedef char *LP_CHAR; ///<   char
typedef int  *LP_INT;  ///<   int
typedef long *LP_LONG; ///<   long

struct linedsc /// LDSC  
{
   char            *text; ///<    (  40)
   unsigned short szline; ///<    
   struct linedsc  *down; ///<  
   struct linedsc    *up; ///<  
   struct linedsc  *next; ///<   
};
typedef struct linedsc LDSC; ///< LDSC  
typedef LDSC *LPLDSC; ///<      LDSC

struct _t_ref ///     
{
   long lBlk; ///<  
   int  iOff; ///<    (    #a2trblk)
};
typedef struct _t_ref T_REF; ///<     

#ifndef H_A2NIKA

#ifdef __cplusplus
 extern "C" {
#endif

int a2dummy0 (void); ///<   0
int a2dummy_1(void); ///<   -1

#ifdef __cplusplus
 }
#endif

#endif /* H_A2NIKA */

#if defined(__FOR_WIN32__)
# define A2_MULTY_PROTOCOLS
#endif

#pragma pack (pop)
#endif /* H_A2SYSDEF */
