/**
  \file   a2tr.h
  \brief     - 
  \author  
  \author  
  \date   13.12.1990
*/

#ifndef   H_A2TR
#define   H_A2TR
#define   A2TR_H
#pragma pack (push, 8)

#ifndef H_A2SYSDEF
# include "a2sysdef.h"
#endif

#ifndef H_A2NIKA
# ifndef H_A2DIO
#  include "a2dio.h"
# endif
#endif

#ifndef H_A2TRDEF
# include "a2trdef.h"
#endif

#define NKNtBegin a2TransBegin
#define NKNtEnd   a2TransEnd
#define NKNtBreak a2TransBreak

#ifdef __cplusplus
extern "C" {
#endif

/** 
       ,      .
    \a type  'r'  'w'     : a2TransBegin(type, time, pt1, ... NULL);
    'u', 'rw'  'wr': a2TransBegin(type, time, pmodes, pt1, ... NULL);
    \a pmodes -          (pt1, pt2, ...),
   \a pt1... -   #TREE, #DDT  #ACCESS
  \param type   : 'r'-, 'w'- ( 'u', 'rw', 'wr')
  \param time     (1 = 55/1000 )
  \return 0    ,   
  \sa a2vTransBegin, a2TransEnd, a2TransBreak, a2TransList
*/
A2EXT int A2EXP a2TransBegin (int type, unsigned time, ...);

/** 
       
  \param type   : 'r'-, 'w'- ( 'u', 'rw', 'wr')
  \param time     (1 = 55/1000 )
  \param pmodes      
      i-    \a pmodes[i],
    \a pmodes != NULL  \a pmodes[i]  'r'  'w',  \a type
  \param pa    #TREE, #DDT  #ACCESS,  NULL.
    DDT     2 ,  ACCESS 3 ( 2 DDT   'r')
  \return 0    ,   
  \sa a2TransBegin, a2TransEnd, a2TransBreak, a2TransList
*/
A2EXT int A2PAS a2vTransBegin(int type, unsigned time, char *pmodes,TREE *pa[]);

/**
     #a2TransBegin  #a2vTransBegin
  \param pt            
  \return 0   
  \sa a2TransBreak
*/
A2EXT int A2PAS a2TransEnd (void *pt);

/**
     #a2TransBegin  #a2vTransBegin
  \param pt            
  \return 0   
  \sa a2TransEnd
*/
A2EXT int A2PAS a2TransBreak (void *pt);

/**
        ,     .
             , DDT  
  2   TREE, ACCESS  3,   .
  \param modes [out] -       
  \param ptrees [out] -      
  \return 0   
*/
A2EXT int A2PAS a2TransList (char *modes, TREE *ptrees[]);

#ifdef __cplusplus
}
#endif

#ifndef   A2DIO_SOURCE

/**
    
*/
enum ETreeErrcodes
{
   // 
   ET_SM   = -1,  ///<  
   ET_SA   = -2,  ///<    
   ET_SB   = -3,  ///<  
   ET_SE   = -4,  ///<  
   ET_SP   = -5,  ///<  
   ET_SV   = -6,  ///<  
   //  
   ET_RMK  = -7,  ///<   
   ET_RMD  = -8,  ///<   
   ET_FERR = -8,  ///<    
   //  
   ET_OR   = -15, ///<    
   ET_OU   = -16, ///<   
   ET_OM   = -17, ///<  
   ET_OE   = -18, ///<  
   ET_CT   = -19, ///<    
   ET_MAR  = -20, ///<       
   ET_MS   = -21, ///<     
   ET_LN   = -22, ///<   
   ET_TRC  = -23, ///<   
   ET_TRR  = -24, ///<    
   ET_MST  = -26, ///<     
// ET_MM   = -27,
   ET_MK   = -28, ///<   
   ET_LKT  = -29, ///<      
   ET_MD   = -30, ///<   
   ET_LK   = -31, ///<    
   ET_LD   = -32, ///<    
   ET_KRD  = -34, ///<       
   ET_ANT  = -35, ///<     
   ET_ANV  = -36, ///<      
   ET_AND  = -37, ///<    
   ET_AEV  = -38, ///<    
   ET_AED  = -39, ///<    
   ET_TRO  = -40, ///<    
   ET_NOK  = -41, ///<    
   ET_RO   = -42, ///<   READ_ONLY 
   ET_BS   = -43, ///<     
   ET_RC   = -44, ///<    
   ET_PC   = -45, ///<    
   ET_AC   = -46, ///<   
   ET_INT  = -47, ///<      
};

#if (defined(__FOR_WINDOWS__) || defined(__FOR_WIN32__)) && defined(H_A2NIKA)
# define TREESKD(e,p,m,o, kt,k,dt,d) {*e=TreeSKD(p, m, o, kt, k, dt, d);}
# define TREESK(err,ptr,m1,a,kt1,k1) {*err=TreeSK( ptr, m1, a, kt1, k1);}
# define TREESD(err,ptr,m1,a,vt1,v1) {*err=TreeSD( ptr, m1, a, vt1, v1);}
# define TREES(err,ptr,m1,a)         {*err=TreeS( ptr, m1, a);          }
# define TREECPY(err,mv,ptr1,ptr2)   {*err=TreeCPY( mv, ptr1, &ptr2);   }
# define TREEDUP(err,ptr1,ptr2)      {*err=TreeDUP( ptr1, &ptr2);       }
# define TREEDLT(err,ptr1,ptr2)      {*err=TreeDLT( ptr1, &ptr2);       }
# define TREESAV(err,pt)             {*err=TreeSAV( pt );               }
# define TREERST(err,pt)             {*err=TreeRST( pt );               }
# define TREECP(err,ptr,fc)          {*err=TreeCP(ptr);                 }
#else
# define TREESKD(e,p,m,a,kt,k,dt,d) {*e=a2tr1c(p,m,a, kt,k, dt,d, 3);}
# define TREESK(e,p,m,a,kt,k) {*e=a2tr1c(p, m, a, kt, k, 0, NULL, 1);}
# define TREESD(e,p,m,a,dt,d) {*e=a2tr1c(p, m, a, 0, NULL, dt, d, 2);}
# define TREES(err,ptr,m1,a) {*err=a2tr1c(ptr, m1,a, 0,NULL, 0,NULL, 0);}
# define TREECPY(e,mv,ptr1,ptr2) {*e=a2tr1c(ptr1,S_O,mv,0,NULL,0,&ptr2,2);}
# define TREEDUP(err,ptr1,ptr2) {*err=a2tr1c(ptr1,S_O,D_P,0,NULL,0,&ptr2,2);}
# define TREEDLT(err,ptr1,ptr2) {*err=a2tr1c(ptr1,S_O,R_C,0,NULL,0,&ptr2,2);}
# define TREESAV(err,pt) {*err=a2tr1c(pt, S_O,S_P, 0,NULL, 0,NULL, 0);}
# define TREERST(err,pt) {*err=a2tr1c(pt, S_O,R_P, 0,NULL, 0,NULL, 0);}
# define TREECP(err,ptr,fc) a2dacp(err, ptr->pdf, fc)
#endif
#define TREESCPY TREECPY
#define TREESDUP TREEDUP
#define TREESDLT TREEDLT
#define TREESSAV TREESAV
#define TREESRST TREERST

#define TREEPACKP TreePACKP
#define TreePACKP(ptree,t) ptree->pack=t ///<   
#define TREEPACK TreePACK
#define TreePACK(ptree) (ptree->pack & 1) ///<   

#define TREETRACEP TreeTRACEP
/**    #ETraceFlags    */
#define TreeTRACEP(ptree,t,st)                     \
    strncpy_s(ptree->trid,sizeof(ptree->trid),st,sizeof(ptree->trid)-1), \
    ptree->trc = t;
#define TREETRACE TreeTRACE
#define TreeTRACE(ptree) (ptree->trc) ///<   


#define TREEERMSGP TreeERMSGP
#define TreeERMSGP(ptree,t) ptree->emsg=t ///<    #EMsgFlags
#define TREEERMSG TreeERMSG
#define TreeERMSG(ptree) (ptree->emsg) ///<   

#define TREELVL TreeLVL
#define TreeLVL(ptree) (ptree->lvl) ///<    (local level)
#define TREEGLVL TreeGLVL
#define TreeGLVL(ptree) (ptree->gllvl) ///<   (global level)

#define TREEVTYPE TreeVTYPE
#define TreeVTYPE(ptree) (ptree->cm.vt) ///<  
#define TREEKTYPE TreeKTYPE
#define TreeKTYPE(ptree) (ptree->cm.kt) ///<  

#define TREETRANS TreeTRANS
#define TreeTRANS(ptree) (ptree->pdf->trType1) ///<  

#define TreeCT(ptree) ((int)ptree->pdf->blk0.codeTable) ///<  

#ifdef __cplusplus
extern "C" {
#endif

#if (defined(__FOR_WINDOWS__) || defined(__FOR_WIN32__)) && defined(H_A2NIKA) && !defined(SOURCE_A2TREE)
# define a2trop(pce,file,disp,pblks,user) TreeOpen(pce,file,disp)
# define a2trop_ex(pce,file,disp,pblks,user,sub,tout) TreeOpenEx(pce,file,disp,sub,tout)
# define a2trcltr TreeClose
#else
 TREE *a2trop (int *pce, char *file, int disp, int *pblks, void *user);
 TREE *a2trop_ex
 ( int *pce, char *file, int disp, int *pblks, void *user, a2dioSubscribeSet* sub, unsigned tout);
 int a2trcltr (TREE *ptree);
#endif

#ifndef H_A2NIKA

int a2trmove(TREE *pctree, TCOMMAND *pcommand);
int a2tr1c  (TREE *pt,char m,char a,char kt,void *k,char vt,void *v,char na);
int a2trcmp (void *p1, void *p2, char type);

#endif

#ifdef __cplusplus
}
#endif

#endif /* A2DIO_SOURCE */

#pragma pack (pop)
#endif /* H_A2TR */
