/**
  \file   a2trdef.h
  \brief     (//) -  
  \author  
  \date   13.12.1990
*/

#ifndef   H_A2TRDEF
#define   H_A2TRDEF
#define   A2TRDEF_H
#pragma pack (push, 8)

#ifndef H_A2SYSDEF
# include "a2sysdef.h"
#endif

#ifndef H_A2DIO
# include "a2dio.h"
#endif

/**
    /  //
*/
enum EMoveActionCodes
{
   T_S = 1,  ///<   (stack align) -  
   J_P = 2,  ///<    (jump on reference) -  
   D_R = 3,  ///<   ,   (down root)
   U_S = 4,  ///<    (up stack)
   //    5
   U_H = 6,  ///<     (up head)
   U_L = 7,  ///<      (up local)
   U_G = 8,  ///<      (up global)
   //    9
   L_K = 10, ///<      (level key)
   L_F = 11, ///<    (level first)
   L_L = 12, ///<    (level last)
   //    13
   L_P = 14, ///<   (level previous)
   L_N = 15, ///<     (level next)
   L_T = 16, ///<     (level type) -  
   D_K = 17, ///<    (down key)
   D_F = 18, ///<     (down first son)
   D_L = 19, ///<     (down last)
   D_T = 20, ///<    (down type) -  
   S_O = 21, ///<    (stay on)
   //    22
   //    23
   N_A = 24, ///<    (no action)
   //    25
   U_V = 26, ///<   (update vertex)
   U_K = 27, ///<   (update key)
   U_D = 28, ///<   (update data)
   R_V = 29, ///<   (read vertex)
   R_K = 30, ///<   (read key)
   R_D = 31, ///<   (read data)
   W_V = 32, ///<  (write vertex)
   W_K = 33, ///<   (write key)
   W_D = 34, ///<   (write data)
   D_V = 35, ///<   (delete vertex)
   D_D = 36, ///<   (delete data)
   E_V = 37, ///<      (delete vertex with error indication)
   E_D = 38, ///<      (delete vertex with error indication)
   //    39
   C_V = 40, ///<   (copy vertex)
   C_D = 41, ///<   [] (copy data [subtree])
   M_V = 42, ///<   (move vertex)
   CM_D= 43, ///<   [] (move data [subtree])
   D_P = 44, ///<   (duplicate process)
   R_C = 45, ///<    (delete copy of process)
   S_P = 46, ///<      (save process)
   R_P = 47, ///<    (restore process)
   A_T = 48, ///<   (add subtrees)
   S_T = 49, ///<   (subtract subtrees)
   C_T = 50, ///<   (cross subtrees)
   O_P = 51, ///<   (open process)
   C_P = 52, ///<   (close process)
};

/**
       
*/
enum ENikaDataTypes
{
   TY_M     = 0,    ///<   (empty: TREE/DDT/ACS)
   TY_T     = 1,    ///<  (text: TREE/DDT/ACS)
   TY_I     = 4,    ///<  (long int: TREE/DDT/ACS)
   TY_F     = 5,    ///<   (float: TREE/DDT/ACS)
   TY_D     = 6,    ///<  (double: TREE/DDT/ACS)
   TY_R     = 12,   ///<    (reference: DDT/ACS)
   TY_P     = 14,   ///<    (patern: DDT only)
   TY_X     = 15,   ///<   ,   (#XDSC: TREE/DDT/ACS)
   TY_S     = 17,   ///< = (structure: TREE/DDT/ACS)
   TY_A     = 18,   ///<  (array: TREE/DDT/ACS)
   TY_U     = 19,   ///< (unit: reserved)
   TY_V     = 20,   ///< (void structure: reserved)
   TY_B     = 32,   ///<   (base type: ACS)
   //
   TY_TC    = 33,   ///< char - text (CONV)
   TY_C     = TY_TC,///< char (CONV)
   TY_IC    = 34,   ///< signed char (CONV)
   TY_IS    = 35,   ///< short (CONV)
   TY_II    = 36,   ///< int (CONV)
   TY_IL    = TY_I, ///< long (CONV)
   TY_UC    = 37,   ///< unsigned char (CONV)
   TY_US    = 38,   ///< unsigned short (CONV)
   TY_UI    = 39,   ///< unsigned int (CONV)
   TY_UL    = 40,   ///< unsigned long (CONV)
   TY_FB    = 41,   ///<   [base format] (CONV)
   TY_TL    = 42,   ///< LDSC (CONV)
   TY_DI    = 43,   ///<  - long (CONV)
   TY_DS    = 44,   ///<  -  (CONV)
   TY_HI    = 45,   ///<  - long (CONV)
   TY_HS    = 46,   ///<  -  (CONV)
   TY_FD    = 47,   ///<  -   (CONV)
   TY_FH    = 48,   ///<  -   (CONV)
   //
   TY_RQS   = 98,   ///<      (TV)
   TY_RQ    = 99,   ///<     ,    (TV)
   //
   TY_MONEY = 128   ///<    ,   ctsr
};

enum E_VertexType      ///    
{
   V_V = 1,            ///<  
   V_O = 2,            ///< 
   V_R = 3,            ///< 
};

enum E_PseudoStates    ///  
{
   TS_N = 0,           ///<   
   TS_M = 1,           ///<   
   TS_A = 2,           ///<  
   TS_B = 3,           ///<   
   TS_E = 4,           ///<   
   TS_P = 5,           ///<    
   TS_V = 6,           ///<  
};

/**
  \brief    
        ()  
*/
struct a2trstln
{
   struct a2trstln *sl; ///<     
   unsigned short    d; ///<   
   char              k; ///<  : #E_VertexType
   char             gs; ///< : #E_PseudoStates
   T_REF             r; ///<   
};
typedef struct a2trstln STKLINE; ///<    

struct a2trcomm ///  
{
   char             m; ///<  
   char             d; ///<  
   char            kt; ///<  
   char            *k; ///<   
   char            vt; ///<   ()
   char            *v; ///<   
   struct a2trcomm *p; ///<    
};
typedef struct a2trcomm TCOMMAND; ///<  

/**
  \brief      
      
*/  
struct a2trtree
{
   char         cbname[4]; ///<   ("TRE")
   DAFILE            *pdf; ///<      
   char               *nf; ///<   
   struct    a2trstln *sl; ///<  
   struct   a2trstln *sl1; ///<    (  )
   struct    a2trtree *pt; ///<       
   struct    a2trtree *pf; ///<       
   char          trid[12]; ///<  
   struct a2trtree *trnxt; ///<      
   void              *ppd; ///<    
   short             blks; ///<  
   TCOMMAND            cm; ///<   
   char               atr; ///<    ()
   short              lvl; ///<     (local level)
   short            gllvl; ///<    (global level)
   long            lBound; ///<          
   char               nba; ///<       
   char              emsg; ///<     #EMsgFlags
   char               trc; ///<   #ETraceFlags
   char              pack; ///<   
   char                 u; ///<   
   char             vtree; ///<   
   char         transType; ///<  
   char                ro; ///<  '  '
   short            o_lvl; ///<  'lvl'     
   short          o_gllvl; ///<  'glvl'     
};
typedef struct a2trtree TREE; ///<      

struct xdsc ///   
{
   long lth; ///<  
   void *xp; ///<   
};
typedef struct xdsc XDSC; ///<   

#pragma pack (push, 1)

struct ddtdata ///    
{
   char     t; ///<  
   long    ut; ///<   
   long    ln; ///<      
   union {
      long df; ///<   
      long as; ///<   
   } u;
   char pf[3]; ///<  
   char     k; ///<    
   char    kt; ///<  
   short   ra; ///<   
   short   wa; ///<   
   long   res; ///< 
};

struct ddtfd ///        
{
   struct ddtdata d; ///<  
   long         key; ///< 
   LDSC         *ld; ///<  
   LDSC        *ldt; ///<  
};
typedef struct ddtfd DDTINF; ///<        

struct fxdata ///     
{
   unsigned long   l; ///<  
   void           *a; ///<  
   struct  ddtdata d; ///<  
   unsigned long  dk; ///<   
};


struct accreftr ///     
{
   short nxt; ///<    
   long   dk; ///<  
   char   kt; ///<  
   char   fl; ///<  : [1-3] , [4,5]   , 6  , 7 
};

#pragma pack (pop)

struct a2ddthsh ///     
{
   long               dk; ///<   
   long              u_t; ///<  
   long              l_f; ///<    
   long              l_l; ///<    
   long              l_p; ///<    
   long              l_n; ///<    
   long              d_f; ///<  
   long              d_l; ///<  
   long              org; ///<   
   char             type; ///<  
   char                k; ///<    
   char            ktype; ///<  
   char            pf[3]; ///<  
   LDSC              *ld; ///< 
   unsigned short   nxtk; ///<      
   unsigned short   pvsk; ///<      
   unsigned short   nxtn; ///<      
   unsigned short   pvsn; ///<      
   unsigned short nxtput; ///<  
   unsigned short pvsput; ///<  
   long              res; ///< 
};

struct a2ddtstr ///        ()
{
   char          cbname[4]; ///<  ("DDT")
   TREE                 *k; ///<  
   TREE                 *n; ///<  
   struct a2ddtstr     *pd; ///<       
   struct a2ddtstr     *pf; ///<        
   struct a2trstln     *sl; ///<   
   char                trc; ///<  
   char           trid[12]; ///<  
   char              vtree; ///<   
   short                vs; ///< 
   short               lvl; ///<   
   short             gllvl; ///<   
   TCOMMAND             cm; ///<   
   char               emsg; ///<  
   short             ifree; ///<      
   short            ifirst; ///<     
   short               icl; ///<     
   char                 as; ///<     
   char               base; ///<    
   unsigned           *enk; ///<       
   unsigned           *enn; ///<      
   struct a2ddthsh vx [10]; ///<  
};
typedef struct a2ddtstr DDT; ///<        ()

#ifndef H_A2NIKA
extern unsigned a2ddtbs;
#endif

struct accref ///      
{
   long    dk; ///<   
   short   nr; ///<    
   short  beg; ///<   
   TREE   *pt; ///<   
   short nxtk; ///<  
   short pvsk; ///<  
   short nxtp; ///<     
   short pvsp; ///<     
   char    fl; ///< : &1 -  , &2  
};

enum EAccHashSizes   ///   
{
   RFNUM  = 10,      ///<  
   ENSIZE = RFNUM*2, ///<   
   TSIZE  = RFNUM*5, ///<  
};

struct a2acc ///      ()
{
   char          cbname[4]; ///<  ("ACS")
   TREE                *pt; ///<    
   DDT                 *pd; ///<   
   char              vtree; ///<  
   short             gllvl; ///<   
   short               lvl; ///<   
   char             keylvl; ///<   
   char              keyno; ///<  
   char               type; ///<  
   char              ktype; ///<  
   long                 dk; ///<   
   char               emsg; ///<  
   char                trc; ///<  
   char           trid[12]; ///<  
   char               rftr; ///<      
   char              rstop; ///<   
   char                  u; ///<   
   char                atr; ///<   
   char                fl1; ///< 
   TCOMMAND             cm; ///<   
   struct a2acc       *pch; ///<   
   short            minlvl; ///<   ( )
   char                fch; ///<    
   struct {
      char          ifreer; ///<    
      char          ifreet; ///<    
      char             icl; ///<     
      char          ifirst; ///<     
      struct accref   hr[RFNUM];  ///<   
      struct accreftr tr[TSIZE];  ///<    
      unsigned short  en[ENSIZE]; ///<    
   } ht;
};
typedef struct a2acc ACCESS; ///<      ()

/**
     
*/
enum EMsgFlags
{
   EM_S = 1, ///<   
   EM_P = 2, ///< + 
   EM_T = 4, ///< + 
};

/**
   
*/
enum ETraceFlags
{
   TR_OFF   = 0,  ///<   
   TR_ON    = 1,  ///<  
   TR_PARM  = 2,  ///< +  
   TR_STK   = 4,  ///< + 
   TR_BLK   = 8,  ///< + 
   TR_TRANS = 16, ///< + 
};

#pragma pack (pop)
#endif /* H_A2TRDEF */
