/**
  \file   a2tvdef.h
  \brief    -   
  \author  
  \date   13.12.1990
*/

#ifndef H_A2TVDEF
#define H_A2TVDEF
#define A2TVDEF_H
#pragma pack (push, 8)

#ifndef H_A2SYSDEF
# include "../include/a2sysdef.h"
#endif

#ifdef _MSC_VER
# pragma warning (disable : 4201) // nameless union
#endif

struct _tint ///   
{
   short row; ///<   (0 ==  )
   short clm; ///<  
};
typedef struct _tint TINT; ///<   

typedef struct wcbdsc WCB; ///<  
typedef struct pcbdsc PCB; ///<   

struct _pfus ///    -   
{
   int p;              ///< call parameter
   union {
      WCB *wcb;        ///< 
      WCB *win;        ///<     (       )
   };
   PCB *pcb;           ///< 
   TINT wcor;          ///<  
   TINT tk;            ///< ?
   TINT tmp;           ///< ?
   char *partname;     ///<  
   unsigned int key;   ///<   
   unsigned char liter;///< ASCII   
   unsigned int regk;  ///<   
   TINT oldsize;       ///<   
   int  brd_sys;       ///<   
};
typedef struct _pfus PFUS; ///<   -   

#pragma pack (push, 1)

#ifndef _WCB_T
#define _WCB_T
struct wcbdsc ///  
{
   short flags;           ///< 
   TINT wpos;             ///<   
   TINT wsize;            ///< 
   TINT tsize;            ///<   
   unsigned char frm;     ///< 
   unsigned char clr1;    ///<  
   unsigned char clr2;    ///<  
   unsigned char clr3;    ///<   
   unsigned char frtype;  ///<  
   unsigned char frclr;   ///<  
   short flagsn;          ///<  
   char pform[6];         ///<     
   TINT bb;               ///<    
   TINT eb;               ///<   
   TINT wint;             ///<     (LDSC)
   LDSC *text;            ///<  
   struct wcbdsc *next;   ///<  
   struct wcbdsc *prev;   ///<  
   LDSC *help;            ///<   
   LDSC *dflt;            ///<    
   LDSC *admch;           ///<   ( WF_ED  -  ALT-)
   char *name;            ///<  
   int (*fch)(PFUS *);    ///<     
   void *down;            ///< /* subordinate element        */
   LDSC *tfrm;            ///<  
   LDSC *path;            ///<     
   LDSC *list;            ///<  
   LDSC *user;            ///<  
   LDSC *ahelp;           ///< 
   LDSC *pattern;         ///<   , , ,  ( 39 )
                          ///<        " "
   LDSC *formula;         ///<   
};
#endif

#ifndef _PCB_T
#define _PCB_T
struct pcbdsc ///   
{
   long flags;          ///<   /
   short fprint;        ///<    
   unsigned char nprow; ///<  
   unsigned char gbase; ///<   
   unsigned char hcol;  ///<    
   unsigned char bcol;  ///<   
   short partlvl;       ///<   
   LDSC *psons;         ///<    
   LDSC *path;          ///<     
   WCB *part;           ///<  
   WCB *fwindow;        ///<     
   WCB *twindow;        ///<    
   struct pcbdsc *next; ///<  
   struct pcbdsc *prev; ///<  
   void *up;            ///<  
   void *store;         ///<    
   short baselvl;       ///<   
};
#endif

#ifndef _PATH_T
#define _PATH_T
struct _path ///  
{
   unsigned char nbase;    ///<    
   short flagsn;           ///< :   0x2020
   char reserv[8];         ///< 
   char part[25];          ///<   
};
typedef struct _path PATH; ///<  
#endif

#pragma pack (pop)

#ifndef _DOC_T
#define _DOC_T
struct _doc ///  
{
   short flags;          ///< 
   char *docname;        ///<  
   void *stream;         ///<    
   PCB *fpart;           ///<   
   PCB *tpart;           ///<   
   int e__npd;           ///< current number of period
   int (*filhpg)(void *);///< ZS fulfillment program
   int (*filfpg)(void *);///< KS fulfillment program
   void  *varlvl;        ///< levels variables
};
typedef struct _doc DOC; ///<  
#endif

#ifndef _FRCB_T
#define _FRCB_T
#define N_FRCB "!_FRCB"
struct _frcb ///  
{
   long flags;   ///< 
   LDSC *stpart; ///<   
   LDSC *spbase; ///<    
   LDSC *user;   ///<  
};
typedef struct _frcb FRCB; ///  
#endif

#ifndef _ULCB_T
#define _ULCB_T
enum ULCB_sizes ///   #ULCB
{
   SZSTR = 9, ///<    
   SZLB  = 4  ///<  
};
struct a2ulcb ///   
{
   char label[SZLB];    ///<  -- "UCB"
   short flags;         ///<  
   char stream[SZSTR];  ///<  
   struct a2ulcb *next; ///<  
   struct a2ulcb *prev; ///<  
   short e__lpage;      ///<  
   short e__npage;      ///<   
   short e__nrow;       ///<    
   PCB *fe;             ///<    
   PCB *le;             ///<    
   DOC *doc;            ///<  
   int (*ufc)(struct a2ulcb *); ///<  
   void *cb;            ///<  
   short LineInOut;     ///<    
   unsigned AnyKey ;    ///<    "PRESS ANY KEY"
};
typedef struct a2ulcb ULCB; ///<   
#endif

#ifndef _SZ_DPW_T
#define _SZ_DPW_T
union SZ_DPW ///          
{
   WCB  wcb;  ///< 
   PCB  pcb;  ///< 
   DOC  doc;  ///< 
   FRCB frcb; ///< 
};
#endif

#pragma pack (pop)
#endif /* H_A2TVDEF */
